/* Autogenerated: src/ExtractionOCaml/word_by_word_montgomery --static p434 '2^216 * 3^137 - 1' 64 mul square add sub opp from_montgomery to_montgomery nonzero selectznz to_bytes from_bytes */
/* curve description: p434 */
/* requested operations: mul, square, add, sub, opp, from_montgomery, to_montgomery, nonzero, selectznz, to_bytes, from_bytes */
/* m = 0x2341f271773446cfc5fd681c520567bc65c783158aea3fdc1767ae2ffffffffffffffffffffffffffffffffffffffffffffffffffffff (from "2^216 * 3^137 - 1") */
/* machine_wordsize = 64 (from "64") */
/*                                                                    */
/* NOTE: In addition to the bounds specified above each function, all */
/*   functions synthesized for this Montgomery arithmetic require the */
/*   input to be strictly less than the prime modulus (m), and also   */
/*   require the input to be in the unique saturated representation.  */
/*   All functions also ensure that these two properties are true of  */
/*   return values.                                                   */

#include <stdint.h>
typedef unsigned char fiat_p434_uint1;
typedef signed char fiat_p434_int1;
typedef signed __int128 fiat_p434_int128;
typedef unsigned __int128 fiat_p434_uint128;

#if (-1 & 3) != 3
#error "This code only works on a two's complement system"
#endif


/*
 * The function fiat_p434_addcarryx_u64 is an addition with carry.
 * Postconditions:
 *   out1 = (arg1 + arg2 + arg3) mod 2^64
 *   out2 = ⌊(arg1 + arg2 + arg3) / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
static void fiat_p434_addcarryx_u64(uint64_t* out1, fiat_p434_uint1* out2, fiat_p434_uint1 arg1, uint64_t arg2, uint64_t arg3) {
  fiat_p434_uint128 x1 = ((arg1 + (fiat_p434_uint128)arg2) + arg3);
  uint64_t x2 = (uint64_t)(x1 & UINT64_C(0xffffffffffffffff));
  fiat_p434_uint1 x3 = (fiat_p434_uint1)(x1 >> 64);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_p434_subborrowx_u64 is a subtraction with borrow.
 * Postconditions:
 *   out1 = (-arg1 + arg2 + -arg3) mod 2^64
 *   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
static void fiat_p434_subborrowx_u64(uint64_t* out1, fiat_p434_uint1* out2, fiat_p434_uint1 arg1, uint64_t arg2, uint64_t arg3) {
  fiat_p434_int128 x1 = ((arg2 - (fiat_p434_int128)arg1) - arg3);
  fiat_p434_int1 x2 = (fiat_p434_int1)(x1 >> 64);
  uint64_t x3 = (uint64_t)(x1 & UINT64_C(0xffffffffffffffff));
  *out1 = x3;
  *out2 = (fiat_p434_uint1)(0x0 - x2);
}

/*
 * The function fiat_p434_mulx_u64 is a multiplication, returning the full double-width result.
 * Postconditions:
 *   out1 = (arg1 * arg2) mod 2^64
 *   out2 = ⌊arg1 * arg2 / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0xffffffffffffffff]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0xffffffffffffffff]
 */
static void fiat_p434_mulx_u64(uint64_t* out1, uint64_t* out2, uint64_t arg1, uint64_t arg2) {
  fiat_p434_uint128 x1 = ((fiat_p434_uint128)arg1 * arg2);
  uint64_t x2 = (uint64_t)(x1 & UINT64_C(0xffffffffffffffff));
  uint64_t x3 = (uint64_t)(x1 >> 64);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_p434_cmovznz_u64 is a single-word conditional move.
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 */
static void fiat_p434_cmovznz_u64(uint64_t* out1, fiat_p434_uint1 arg1, uint64_t arg2, uint64_t arg3) {
  fiat_p434_uint1 x1 = (!(!arg1));
  uint64_t x2 = ((fiat_p434_int1)(0x0 - x1) & UINT64_C(0xffffffffffffffff));
  uint64_t x3 = ((x2 & arg3) | ((~x2) & arg2));
  *out1 = x3;
}

/*
 * The function fiat_p434_mul multiplies two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
static void fiat_p434_mul(uint64_t out1[7], const uint64_t arg1[7], const uint64_t arg2[7]) {
  uint64_t x1 = (arg1[1]);
  uint64_t x2 = (arg1[2]);
  uint64_t x3 = (arg1[3]);
  uint64_t x4 = (arg1[4]);
  uint64_t x5 = (arg1[5]);
  uint64_t x6 = (arg1[6]);
  uint64_t x7 = (arg1[0]);
  uint64_t x8;
  uint64_t x9;
  fiat_p434_mulx_u64(&x8, &x9, x7, (arg2[6]));
  uint64_t x10;
  uint64_t x11;
  fiat_p434_mulx_u64(&x10, &x11, x7, (arg2[5]));
  uint64_t x12;
  uint64_t x13;
  fiat_p434_mulx_u64(&x12, &x13, x7, (arg2[4]));
  uint64_t x14;
  uint64_t x15;
  fiat_p434_mulx_u64(&x14, &x15, x7, (arg2[3]));
  uint64_t x16;
  uint64_t x17;
  fiat_p434_mulx_u64(&x16, &x17, x7, (arg2[2]));
  uint64_t x18;
  uint64_t x19;
  fiat_p434_mulx_u64(&x18, &x19, x7, (arg2[1]));
  uint64_t x20;
  uint64_t x21;
  fiat_p434_mulx_u64(&x20, &x21, x7, (arg2[0]));
  uint64_t x22;
  fiat_p434_uint1 x23;
  fiat_p434_addcarryx_u64(&x22, &x23, 0x0, x21, x18);
  uint64_t x24;
  fiat_p434_uint1 x25;
  fiat_p434_addcarryx_u64(&x24, &x25, x23, x19, x16);
  uint64_t x26;
  fiat_p434_uint1 x27;
  fiat_p434_addcarryx_u64(&x26, &x27, x25, x17, x14);
  uint64_t x28;
  fiat_p434_uint1 x29;
  fiat_p434_addcarryx_u64(&x28, &x29, x27, x15, x12);
  uint64_t x30;
  fiat_p434_uint1 x31;
  fiat_p434_addcarryx_u64(&x30, &x31, x29, x13, x10);
  uint64_t x32;
  fiat_p434_uint1 x33;
  fiat_p434_addcarryx_u64(&x32, &x33, x31, x11, x8);
  uint64_t x34 = (x33 + x9);
  uint64_t x35;
  uint64_t x36;
  fiat_p434_mulx_u64(&x35, &x36, x20, UINT64_C(0x2341f27177344));
  uint64_t x37;
  uint64_t x38;
  fiat_p434_mulx_u64(&x37, &x38, x20, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x39;
  uint64_t x40;
  fiat_p434_mulx_u64(&x39, &x40, x20, UINT64_C(0x7bc65c783158aea3));
  uint64_t x41;
  uint64_t x42;
  fiat_p434_mulx_u64(&x41, &x42, x20, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x43;
  uint64_t x44;
  fiat_p434_mulx_u64(&x43, &x44, x20, UINT64_C(0xffffffffffffffff));
  uint64_t x45;
  uint64_t x46;
  fiat_p434_mulx_u64(&x45, &x46, x20, UINT64_C(0xffffffffffffffff));
  uint64_t x47;
  uint64_t x48;
  fiat_p434_mulx_u64(&x47, &x48, x20, UINT64_C(0xffffffffffffffff));
  uint64_t x49;
  fiat_p434_uint1 x50;
  fiat_p434_addcarryx_u64(&x49, &x50, 0x0, x48, x45);
  uint64_t x51;
  fiat_p434_uint1 x52;
  fiat_p434_addcarryx_u64(&x51, &x52, x50, x46, x43);
  uint64_t x53;
  fiat_p434_uint1 x54;
  fiat_p434_addcarryx_u64(&x53, &x54, x52, x44, x41);
  uint64_t x55;
  fiat_p434_uint1 x56;
  fiat_p434_addcarryx_u64(&x55, &x56, x54, x42, x39);
  uint64_t x57;
  fiat_p434_uint1 x58;
  fiat_p434_addcarryx_u64(&x57, &x58, x56, x40, x37);
  uint64_t x59;
  fiat_p434_uint1 x60;
  fiat_p434_addcarryx_u64(&x59, &x60, x58, x38, x35);
  uint64_t x61 = (x60 + x36);
  uint64_t x62;
  fiat_p434_uint1 x63;
  fiat_p434_addcarryx_u64(&x62, &x63, 0x0, x20, x47);
  uint64_t x64;
  fiat_p434_uint1 x65;
  fiat_p434_addcarryx_u64(&x64, &x65, x63, x22, x49);
  uint64_t x66;
  fiat_p434_uint1 x67;
  fiat_p434_addcarryx_u64(&x66, &x67, x65, x24, x51);
  uint64_t x68;
  fiat_p434_uint1 x69;
  fiat_p434_addcarryx_u64(&x68, &x69, x67, x26, x53);
  uint64_t x70;
  fiat_p434_uint1 x71;
  fiat_p434_addcarryx_u64(&x70, &x71, x69, x28, x55);
  uint64_t x72;
  fiat_p434_uint1 x73;
  fiat_p434_addcarryx_u64(&x72, &x73, x71, x30, x57);
  uint64_t x74;
  fiat_p434_uint1 x75;
  fiat_p434_addcarryx_u64(&x74, &x75, x73, x32, x59);
  uint64_t x76;
  fiat_p434_uint1 x77;
  fiat_p434_addcarryx_u64(&x76, &x77, x75, x34, x61);
  uint64_t x78;
  uint64_t x79;
  fiat_p434_mulx_u64(&x78, &x79, x1, (arg2[6]));
  uint64_t x80;
  uint64_t x81;
  fiat_p434_mulx_u64(&x80, &x81, x1, (arg2[5]));
  uint64_t x82;
  uint64_t x83;
  fiat_p434_mulx_u64(&x82, &x83, x1, (arg2[4]));
  uint64_t x84;
  uint64_t x85;
  fiat_p434_mulx_u64(&x84, &x85, x1, (arg2[3]));
  uint64_t x86;
  uint64_t x87;
  fiat_p434_mulx_u64(&x86, &x87, x1, (arg2[2]));
  uint64_t x88;
  uint64_t x89;
  fiat_p434_mulx_u64(&x88, &x89, x1, (arg2[1]));
  uint64_t x90;
  uint64_t x91;
  fiat_p434_mulx_u64(&x90, &x91, x1, (arg2[0]));
  uint64_t x92;
  fiat_p434_uint1 x93;
  fiat_p434_addcarryx_u64(&x92, &x93, 0x0, x91, x88);
  uint64_t x94;
  fiat_p434_uint1 x95;
  fiat_p434_addcarryx_u64(&x94, &x95, x93, x89, x86);
  uint64_t x96;
  fiat_p434_uint1 x97;
  fiat_p434_addcarryx_u64(&x96, &x97, x95, x87, x84);
  uint64_t x98;
  fiat_p434_uint1 x99;
  fiat_p434_addcarryx_u64(&x98, &x99, x97, x85, x82);
  uint64_t x100;
  fiat_p434_uint1 x101;
  fiat_p434_addcarryx_u64(&x100, &x101, x99, x83, x80);
  uint64_t x102;
  fiat_p434_uint1 x103;
  fiat_p434_addcarryx_u64(&x102, &x103, x101, x81, x78);
  uint64_t x104 = (x103 + x79);
  uint64_t x105;
  fiat_p434_uint1 x106;
  fiat_p434_addcarryx_u64(&x105, &x106, 0x0, x64, x90);
  uint64_t x107;
  fiat_p434_uint1 x108;
  fiat_p434_addcarryx_u64(&x107, &x108, x106, x66, x92);
  uint64_t x109;
  fiat_p434_uint1 x110;
  fiat_p434_addcarryx_u64(&x109, &x110, x108, x68, x94);
  uint64_t x111;
  fiat_p434_uint1 x112;
  fiat_p434_addcarryx_u64(&x111, &x112, x110, x70, x96);
  uint64_t x113;
  fiat_p434_uint1 x114;
  fiat_p434_addcarryx_u64(&x113, &x114, x112, x72, x98);
  uint64_t x115;
  fiat_p434_uint1 x116;
  fiat_p434_addcarryx_u64(&x115, &x116, x114, x74, x100);
  uint64_t x117;
  fiat_p434_uint1 x118;
  fiat_p434_addcarryx_u64(&x117, &x118, x116, x76, x102);
  uint64_t x119;
  fiat_p434_uint1 x120;
  fiat_p434_addcarryx_u64(&x119, &x120, x118, x77, x104);
  uint64_t x121;
  uint64_t x122;
  fiat_p434_mulx_u64(&x121, &x122, x105, UINT64_C(0x2341f27177344));
  uint64_t x123;
  uint64_t x124;
  fiat_p434_mulx_u64(&x123, &x124, x105, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x125;
  uint64_t x126;
  fiat_p434_mulx_u64(&x125, &x126, x105, UINT64_C(0x7bc65c783158aea3));
  uint64_t x127;
  uint64_t x128;
  fiat_p434_mulx_u64(&x127, &x128, x105, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x129;
  uint64_t x130;
  fiat_p434_mulx_u64(&x129, &x130, x105, UINT64_C(0xffffffffffffffff));
  uint64_t x131;
  uint64_t x132;
  fiat_p434_mulx_u64(&x131, &x132, x105, UINT64_C(0xffffffffffffffff));
  uint64_t x133;
  uint64_t x134;
  fiat_p434_mulx_u64(&x133, &x134, x105, UINT64_C(0xffffffffffffffff));
  uint64_t x135;
  fiat_p434_uint1 x136;
  fiat_p434_addcarryx_u64(&x135, &x136, 0x0, x134, x131);
  uint64_t x137;
  fiat_p434_uint1 x138;
  fiat_p434_addcarryx_u64(&x137, &x138, x136, x132, x129);
  uint64_t x139;
  fiat_p434_uint1 x140;
  fiat_p434_addcarryx_u64(&x139, &x140, x138, x130, x127);
  uint64_t x141;
  fiat_p434_uint1 x142;
  fiat_p434_addcarryx_u64(&x141, &x142, x140, x128, x125);
  uint64_t x143;
  fiat_p434_uint1 x144;
  fiat_p434_addcarryx_u64(&x143, &x144, x142, x126, x123);
  uint64_t x145;
  fiat_p434_uint1 x146;
  fiat_p434_addcarryx_u64(&x145, &x146, x144, x124, x121);
  uint64_t x147 = (x146 + x122);
  uint64_t x148;
  fiat_p434_uint1 x149;
  fiat_p434_addcarryx_u64(&x148, &x149, 0x0, x105, x133);
  uint64_t x150;
  fiat_p434_uint1 x151;
  fiat_p434_addcarryx_u64(&x150, &x151, x149, x107, x135);
  uint64_t x152;
  fiat_p434_uint1 x153;
  fiat_p434_addcarryx_u64(&x152, &x153, x151, x109, x137);
  uint64_t x154;
  fiat_p434_uint1 x155;
  fiat_p434_addcarryx_u64(&x154, &x155, x153, x111, x139);
  uint64_t x156;
  fiat_p434_uint1 x157;
  fiat_p434_addcarryx_u64(&x156, &x157, x155, x113, x141);
  uint64_t x158;
  fiat_p434_uint1 x159;
  fiat_p434_addcarryx_u64(&x158, &x159, x157, x115, x143);
  uint64_t x160;
  fiat_p434_uint1 x161;
  fiat_p434_addcarryx_u64(&x160, &x161, x159, x117, x145);
  uint64_t x162;
  fiat_p434_uint1 x163;
  fiat_p434_addcarryx_u64(&x162, &x163, x161, x119, x147);
  uint64_t x164 = ((uint64_t)x163 + x120);
  uint64_t x165;
  uint64_t x166;
  fiat_p434_mulx_u64(&x165, &x166, x2, (arg2[6]));
  uint64_t x167;
  uint64_t x168;
  fiat_p434_mulx_u64(&x167, &x168, x2, (arg2[5]));
  uint64_t x169;
  uint64_t x170;
  fiat_p434_mulx_u64(&x169, &x170, x2, (arg2[4]));
  uint64_t x171;
  uint64_t x172;
  fiat_p434_mulx_u64(&x171, &x172, x2, (arg2[3]));
  uint64_t x173;
  uint64_t x174;
  fiat_p434_mulx_u64(&x173, &x174, x2, (arg2[2]));
  uint64_t x175;
  uint64_t x176;
  fiat_p434_mulx_u64(&x175, &x176, x2, (arg2[1]));
  uint64_t x177;
  uint64_t x178;
  fiat_p434_mulx_u64(&x177, &x178, x2, (arg2[0]));
  uint64_t x179;
  fiat_p434_uint1 x180;
  fiat_p434_addcarryx_u64(&x179, &x180, 0x0, x178, x175);
  uint64_t x181;
  fiat_p434_uint1 x182;
  fiat_p434_addcarryx_u64(&x181, &x182, x180, x176, x173);
  uint64_t x183;
  fiat_p434_uint1 x184;
  fiat_p434_addcarryx_u64(&x183, &x184, x182, x174, x171);
  uint64_t x185;
  fiat_p434_uint1 x186;
  fiat_p434_addcarryx_u64(&x185, &x186, x184, x172, x169);
  uint64_t x187;
  fiat_p434_uint1 x188;
  fiat_p434_addcarryx_u64(&x187, &x188, x186, x170, x167);
  uint64_t x189;
  fiat_p434_uint1 x190;
  fiat_p434_addcarryx_u64(&x189, &x190, x188, x168, x165);
  uint64_t x191 = (x190 + x166);
  uint64_t x192;
  fiat_p434_uint1 x193;
  fiat_p434_addcarryx_u64(&x192, &x193, 0x0, x150, x177);
  uint64_t x194;
  fiat_p434_uint1 x195;
  fiat_p434_addcarryx_u64(&x194, &x195, x193, x152, x179);
  uint64_t x196;
  fiat_p434_uint1 x197;
  fiat_p434_addcarryx_u64(&x196, &x197, x195, x154, x181);
  uint64_t x198;
  fiat_p434_uint1 x199;
  fiat_p434_addcarryx_u64(&x198, &x199, x197, x156, x183);
  uint64_t x200;
  fiat_p434_uint1 x201;
  fiat_p434_addcarryx_u64(&x200, &x201, x199, x158, x185);
  uint64_t x202;
  fiat_p434_uint1 x203;
  fiat_p434_addcarryx_u64(&x202, &x203, x201, x160, x187);
  uint64_t x204;
  fiat_p434_uint1 x205;
  fiat_p434_addcarryx_u64(&x204, &x205, x203, x162, x189);
  uint64_t x206;
  fiat_p434_uint1 x207;
  fiat_p434_addcarryx_u64(&x206, &x207, x205, x164, x191);
  uint64_t x208;
  uint64_t x209;
  fiat_p434_mulx_u64(&x208, &x209, x192, UINT64_C(0x2341f27177344));
  uint64_t x210;
  uint64_t x211;
  fiat_p434_mulx_u64(&x210, &x211, x192, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x212;
  uint64_t x213;
  fiat_p434_mulx_u64(&x212, &x213, x192, UINT64_C(0x7bc65c783158aea3));
  uint64_t x214;
  uint64_t x215;
  fiat_p434_mulx_u64(&x214, &x215, x192, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x216;
  uint64_t x217;
  fiat_p434_mulx_u64(&x216, &x217, x192, UINT64_C(0xffffffffffffffff));
  uint64_t x218;
  uint64_t x219;
  fiat_p434_mulx_u64(&x218, &x219, x192, UINT64_C(0xffffffffffffffff));
  uint64_t x220;
  uint64_t x221;
  fiat_p434_mulx_u64(&x220, &x221, x192, UINT64_C(0xffffffffffffffff));
  uint64_t x222;
  fiat_p434_uint1 x223;
  fiat_p434_addcarryx_u64(&x222, &x223, 0x0, x221, x218);
  uint64_t x224;
  fiat_p434_uint1 x225;
  fiat_p434_addcarryx_u64(&x224, &x225, x223, x219, x216);
  uint64_t x226;
  fiat_p434_uint1 x227;
  fiat_p434_addcarryx_u64(&x226, &x227, x225, x217, x214);
  uint64_t x228;
  fiat_p434_uint1 x229;
  fiat_p434_addcarryx_u64(&x228, &x229, x227, x215, x212);
  uint64_t x230;
  fiat_p434_uint1 x231;
  fiat_p434_addcarryx_u64(&x230, &x231, x229, x213, x210);
  uint64_t x232;
  fiat_p434_uint1 x233;
  fiat_p434_addcarryx_u64(&x232, &x233, x231, x211, x208);
  uint64_t x234 = (x233 + x209);
  uint64_t x235;
  fiat_p434_uint1 x236;
  fiat_p434_addcarryx_u64(&x235, &x236, 0x0, x192, x220);
  uint64_t x237;
  fiat_p434_uint1 x238;
  fiat_p434_addcarryx_u64(&x237, &x238, x236, x194, x222);
  uint64_t x239;
  fiat_p434_uint1 x240;
  fiat_p434_addcarryx_u64(&x239, &x240, x238, x196, x224);
  uint64_t x241;
  fiat_p434_uint1 x242;
  fiat_p434_addcarryx_u64(&x241, &x242, x240, x198, x226);
  uint64_t x243;
  fiat_p434_uint1 x244;
  fiat_p434_addcarryx_u64(&x243, &x244, x242, x200, x228);
  uint64_t x245;
  fiat_p434_uint1 x246;
  fiat_p434_addcarryx_u64(&x245, &x246, x244, x202, x230);
  uint64_t x247;
  fiat_p434_uint1 x248;
  fiat_p434_addcarryx_u64(&x247, &x248, x246, x204, x232);
  uint64_t x249;
  fiat_p434_uint1 x250;
  fiat_p434_addcarryx_u64(&x249, &x250, x248, x206, x234);
  uint64_t x251 = ((uint64_t)x250 + x207);
  uint64_t x252;
  uint64_t x253;
  fiat_p434_mulx_u64(&x252, &x253, x3, (arg2[6]));
  uint64_t x254;
  uint64_t x255;
  fiat_p434_mulx_u64(&x254, &x255, x3, (arg2[5]));
  uint64_t x256;
  uint64_t x257;
  fiat_p434_mulx_u64(&x256, &x257, x3, (arg2[4]));
  uint64_t x258;
  uint64_t x259;
  fiat_p434_mulx_u64(&x258, &x259, x3, (arg2[3]));
  uint64_t x260;
  uint64_t x261;
  fiat_p434_mulx_u64(&x260, &x261, x3, (arg2[2]));
  uint64_t x262;
  uint64_t x263;
  fiat_p434_mulx_u64(&x262, &x263, x3, (arg2[1]));
  uint64_t x264;
  uint64_t x265;
  fiat_p434_mulx_u64(&x264, &x265, x3, (arg2[0]));
  uint64_t x266;
  fiat_p434_uint1 x267;
  fiat_p434_addcarryx_u64(&x266, &x267, 0x0, x265, x262);
  uint64_t x268;
  fiat_p434_uint1 x269;
  fiat_p434_addcarryx_u64(&x268, &x269, x267, x263, x260);
  uint64_t x270;
  fiat_p434_uint1 x271;
  fiat_p434_addcarryx_u64(&x270, &x271, x269, x261, x258);
  uint64_t x272;
  fiat_p434_uint1 x273;
  fiat_p434_addcarryx_u64(&x272, &x273, x271, x259, x256);
  uint64_t x274;
  fiat_p434_uint1 x275;
  fiat_p434_addcarryx_u64(&x274, &x275, x273, x257, x254);
  uint64_t x276;
  fiat_p434_uint1 x277;
  fiat_p434_addcarryx_u64(&x276, &x277, x275, x255, x252);
  uint64_t x278 = (x277 + x253);
  uint64_t x279;
  fiat_p434_uint1 x280;
  fiat_p434_addcarryx_u64(&x279, &x280, 0x0, x237, x264);
  uint64_t x281;
  fiat_p434_uint1 x282;
  fiat_p434_addcarryx_u64(&x281, &x282, x280, x239, x266);
  uint64_t x283;
  fiat_p434_uint1 x284;
  fiat_p434_addcarryx_u64(&x283, &x284, x282, x241, x268);
  uint64_t x285;
  fiat_p434_uint1 x286;
  fiat_p434_addcarryx_u64(&x285, &x286, x284, x243, x270);
  uint64_t x287;
  fiat_p434_uint1 x288;
  fiat_p434_addcarryx_u64(&x287, &x288, x286, x245, x272);
  uint64_t x289;
  fiat_p434_uint1 x290;
  fiat_p434_addcarryx_u64(&x289, &x290, x288, x247, x274);
  uint64_t x291;
  fiat_p434_uint1 x292;
  fiat_p434_addcarryx_u64(&x291, &x292, x290, x249, x276);
  uint64_t x293;
  fiat_p434_uint1 x294;
  fiat_p434_addcarryx_u64(&x293, &x294, x292, x251, x278);
  uint64_t x295;
  uint64_t x296;
  fiat_p434_mulx_u64(&x295, &x296, x279, UINT64_C(0x2341f27177344));
  uint64_t x297;
  uint64_t x298;
  fiat_p434_mulx_u64(&x297, &x298, x279, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x299;
  uint64_t x300;
  fiat_p434_mulx_u64(&x299, &x300, x279, UINT64_C(0x7bc65c783158aea3));
  uint64_t x301;
  uint64_t x302;
  fiat_p434_mulx_u64(&x301, &x302, x279, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x303;
  uint64_t x304;
  fiat_p434_mulx_u64(&x303, &x304, x279, UINT64_C(0xffffffffffffffff));
  uint64_t x305;
  uint64_t x306;
  fiat_p434_mulx_u64(&x305, &x306, x279, UINT64_C(0xffffffffffffffff));
  uint64_t x307;
  uint64_t x308;
  fiat_p434_mulx_u64(&x307, &x308, x279, UINT64_C(0xffffffffffffffff));
  uint64_t x309;
  fiat_p434_uint1 x310;
  fiat_p434_addcarryx_u64(&x309, &x310, 0x0, x308, x305);
  uint64_t x311;
  fiat_p434_uint1 x312;
  fiat_p434_addcarryx_u64(&x311, &x312, x310, x306, x303);
  uint64_t x313;
  fiat_p434_uint1 x314;
  fiat_p434_addcarryx_u64(&x313, &x314, x312, x304, x301);
  uint64_t x315;
  fiat_p434_uint1 x316;
  fiat_p434_addcarryx_u64(&x315, &x316, x314, x302, x299);
  uint64_t x317;
  fiat_p434_uint1 x318;
  fiat_p434_addcarryx_u64(&x317, &x318, x316, x300, x297);
  uint64_t x319;
  fiat_p434_uint1 x320;
  fiat_p434_addcarryx_u64(&x319, &x320, x318, x298, x295);
  uint64_t x321 = (x320 + x296);
  uint64_t x322;
  fiat_p434_uint1 x323;
  fiat_p434_addcarryx_u64(&x322, &x323, 0x0, x279, x307);
  uint64_t x324;
  fiat_p434_uint1 x325;
  fiat_p434_addcarryx_u64(&x324, &x325, x323, x281, x309);
  uint64_t x326;
  fiat_p434_uint1 x327;
  fiat_p434_addcarryx_u64(&x326, &x327, x325, x283, x311);
  uint64_t x328;
  fiat_p434_uint1 x329;
  fiat_p434_addcarryx_u64(&x328, &x329, x327, x285, x313);
  uint64_t x330;
  fiat_p434_uint1 x331;
  fiat_p434_addcarryx_u64(&x330, &x331, x329, x287, x315);
  uint64_t x332;
  fiat_p434_uint1 x333;
  fiat_p434_addcarryx_u64(&x332, &x333, x331, x289, x317);
  uint64_t x334;
  fiat_p434_uint1 x335;
  fiat_p434_addcarryx_u64(&x334, &x335, x333, x291, x319);
  uint64_t x336;
  fiat_p434_uint1 x337;
  fiat_p434_addcarryx_u64(&x336, &x337, x335, x293, x321);
  uint64_t x338 = ((uint64_t)x337 + x294);
  uint64_t x339;
  uint64_t x340;
  fiat_p434_mulx_u64(&x339, &x340, x4, (arg2[6]));
  uint64_t x341;
  uint64_t x342;
  fiat_p434_mulx_u64(&x341, &x342, x4, (arg2[5]));
  uint64_t x343;
  uint64_t x344;
  fiat_p434_mulx_u64(&x343, &x344, x4, (arg2[4]));
  uint64_t x345;
  uint64_t x346;
  fiat_p434_mulx_u64(&x345, &x346, x4, (arg2[3]));
  uint64_t x347;
  uint64_t x348;
  fiat_p434_mulx_u64(&x347, &x348, x4, (arg2[2]));
  uint64_t x349;
  uint64_t x350;
  fiat_p434_mulx_u64(&x349, &x350, x4, (arg2[1]));
  uint64_t x351;
  uint64_t x352;
  fiat_p434_mulx_u64(&x351, &x352, x4, (arg2[0]));
  uint64_t x353;
  fiat_p434_uint1 x354;
  fiat_p434_addcarryx_u64(&x353, &x354, 0x0, x352, x349);
  uint64_t x355;
  fiat_p434_uint1 x356;
  fiat_p434_addcarryx_u64(&x355, &x356, x354, x350, x347);
  uint64_t x357;
  fiat_p434_uint1 x358;
  fiat_p434_addcarryx_u64(&x357, &x358, x356, x348, x345);
  uint64_t x359;
  fiat_p434_uint1 x360;
  fiat_p434_addcarryx_u64(&x359, &x360, x358, x346, x343);
  uint64_t x361;
  fiat_p434_uint1 x362;
  fiat_p434_addcarryx_u64(&x361, &x362, x360, x344, x341);
  uint64_t x363;
  fiat_p434_uint1 x364;
  fiat_p434_addcarryx_u64(&x363, &x364, x362, x342, x339);
  uint64_t x365 = (x364 + x340);
  uint64_t x366;
  fiat_p434_uint1 x367;
  fiat_p434_addcarryx_u64(&x366, &x367, 0x0, x324, x351);
  uint64_t x368;
  fiat_p434_uint1 x369;
  fiat_p434_addcarryx_u64(&x368, &x369, x367, x326, x353);
  uint64_t x370;
  fiat_p434_uint1 x371;
  fiat_p434_addcarryx_u64(&x370, &x371, x369, x328, x355);
  uint64_t x372;
  fiat_p434_uint1 x373;
  fiat_p434_addcarryx_u64(&x372, &x373, x371, x330, x357);
  uint64_t x374;
  fiat_p434_uint1 x375;
  fiat_p434_addcarryx_u64(&x374, &x375, x373, x332, x359);
  uint64_t x376;
  fiat_p434_uint1 x377;
  fiat_p434_addcarryx_u64(&x376, &x377, x375, x334, x361);
  uint64_t x378;
  fiat_p434_uint1 x379;
  fiat_p434_addcarryx_u64(&x378, &x379, x377, x336, x363);
  uint64_t x380;
  fiat_p434_uint1 x381;
  fiat_p434_addcarryx_u64(&x380, &x381, x379, x338, x365);
  uint64_t x382;
  uint64_t x383;
  fiat_p434_mulx_u64(&x382, &x383, x366, UINT64_C(0x2341f27177344));
  uint64_t x384;
  uint64_t x385;
  fiat_p434_mulx_u64(&x384, &x385, x366, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x386;
  uint64_t x387;
  fiat_p434_mulx_u64(&x386, &x387, x366, UINT64_C(0x7bc65c783158aea3));
  uint64_t x388;
  uint64_t x389;
  fiat_p434_mulx_u64(&x388, &x389, x366, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x390;
  uint64_t x391;
  fiat_p434_mulx_u64(&x390, &x391, x366, UINT64_C(0xffffffffffffffff));
  uint64_t x392;
  uint64_t x393;
  fiat_p434_mulx_u64(&x392, &x393, x366, UINT64_C(0xffffffffffffffff));
  uint64_t x394;
  uint64_t x395;
  fiat_p434_mulx_u64(&x394, &x395, x366, UINT64_C(0xffffffffffffffff));
  uint64_t x396;
  fiat_p434_uint1 x397;
  fiat_p434_addcarryx_u64(&x396, &x397, 0x0, x395, x392);
  uint64_t x398;
  fiat_p434_uint1 x399;
  fiat_p434_addcarryx_u64(&x398, &x399, x397, x393, x390);
  uint64_t x400;
  fiat_p434_uint1 x401;
  fiat_p434_addcarryx_u64(&x400, &x401, x399, x391, x388);
  uint64_t x402;
  fiat_p434_uint1 x403;
  fiat_p434_addcarryx_u64(&x402, &x403, x401, x389, x386);
  uint64_t x404;
  fiat_p434_uint1 x405;
  fiat_p434_addcarryx_u64(&x404, &x405, x403, x387, x384);
  uint64_t x406;
  fiat_p434_uint1 x407;
  fiat_p434_addcarryx_u64(&x406, &x407, x405, x385, x382);
  uint64_t x408 = (x407 + x383);
  uint64_t x409;
  fiat_p434_uint1 x410;
  fiat_p434_addcarryx_u64(&x409, &x410, 0x0, x366, x394);
  uint64_t x411;
  fiat_p434_uint1 x412;
  fiat_p434_addcarryx_u64(&x411, &x412, x410, x368, x396);
  uint64_t x413;
  fiat_p434_uint1 x414;
  fiat_p434_addcarryx_u64(&x413, &x414, x412, x370, x398);
  uint64_t x415;
  fiat_p434_uint1 x416;
  fiat_p434_addcarryx_u64(&x415, &x416, x414, x372, x400);
  uint64_t x417;
  fiat_p434_uint1 x418;
  fiat_p434_addcarryx_u64(&x417, &x418, x416, x374, x402);
  uint64_t x419;
  fiat_p434_uint1 x420;
  fiat_p434_addcarryx_u64(&x419, &x420, x418, x376, x404);
  uint64_t x421;
  fiat_p434_uint1 x422;
  fiat_p434_addcarryx_u64(&x421, &x422, x420, x378, x406);
  uint64_t x423;
  fiat_p434_uint1 x424;
  fiat_p434_addcarryx_u64(&x423, &x424, x422, x380, x408);
  uint64_t x425 = ((uint64_t)x424 + x381);
  uint64_t x426;
  uint64_t x427;
  fiat_p434_mulx_u64(&x426, &x427, x5, (arg2[6]));
  uint64_t x428;
  uint64_t x429;
  fiat_p434_mulx_u64(&x428, &x429, x5, (arg2[5]));
  uint64_t x430;
  uint64_t x431;
  fiat_p434_mulx_u64(&x430, &x431, x5, (arg2[4]));
  uint64_t x432;
  uint64_t x433;
  fiat_p434_mulx_u64(&x432, &x433, x5, (arg2[3]));
  uint64_t x434;
  uint64_t x435;
  fiat_p434_mulx_u64(&x434, &x435, x5, (arg2[2]));
  uint64_t x436;
  uint64_t x437;
  fiat_p434_mulx_u64(&x436, &x437, x5, (arg2[1]));
  uint64_t x438;
  uint64_t x439;
  fiat_p434_mulx_u64(&x438, &x439, x5, (arg2[0]));
  uint64_t x440;
  fiat_p434_uint1 x441;
  fiat_p434_addcarryx_u64(&x440, &x441, 0x0, x439, x436);
  uint64_t x442;
  fiat_p434_uint1 x443;
  fiat_p434_addcarryx_u64(&x442, &x443, x441, x437, x434);
  uint64_t x444;
  fiat_p434_uint1 x445;
  fiat_p434_addcarryx_u64(&x444, &x445, x443, x435, x432);
  uint64_t x446;
  fiat_p434_uint1 x447;
  fiat_p434_addcarryx_u64(&x446, &x447, x445, x433, x430);
  uint64_t x448;
  fiat_p434_uint1 x449;
  fiat_p434_addcarryx_u64(&x448, &x449, x447, x431, x428);
  uint64_t x450;
  fiat_p434_uint1 x451;
  fiat_p434_addcarryx_u64(&x450, &x451, x449, x429, x426);
  uint64_t x452 = (x451 + x427);
  uint64_t x453;
  fiat_p434_uint1 x454;
  fiat_p434_addcarryx_u64(&x453, &x454, 0x0, x411, x438);
  uint64_t x455;
  fiat_p434_uint1 x456;
  fiat_p434_addcarryx_u64(&x455, &x456, x454, x413, x440);
  uint64_t x457;
  fiat_p434_uint1 x458;
  fiat_p434_addcarryx_u64(&x457, &x458, x456, x415, x442);
  uint64_t x459;
  fiat_p434_uint1 x460;
  fiat_p434_addcarryx_u64(&x459, &x460, x458, x417, x444);
  uint64_t x461;
  fiat_p434_uint1 x462;
  fiat_p434_addcarryx_u64(&x461, &x462, x460, x419, x446);
  uint64_t x463;
  fiat_p434_uint1 x464;
  fiat_p434_addcarryx_u64(&x463, &x464, x462, x421, x448);
  uint64_t x465;
  fiat_p434_uint1 x466;
  fiat_p434_addcarryx_u64(&x465, &x466, x464, x423, x450);
  uint64_t x467;
  fiat_p434_uint1 x468;
  fiat_p434_addcarryx_u64(&x467, &x468, x466, x425, x452);
  uint64_t x469;
  uint64_t x470;
  fiat_p434_mulx_u64(&x469, &x470, x453, UINT64_C(0x2341f27177344));
  uint64_t x471;
  uint64_t x472;
  fiat_p434_mulx_u64(&x471, &x472, x453, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x473;
  uint64_t x474;
  fiat_p434_mulx_u64(&x473, &x474, x453, UINT64_C(0x7bc65c783158aea3));
  uint64_t x475;
  uint64_t x476;
  fiat_p434_mulx_u64(&x475, &x476, x453, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x477;
  uint64_t x478;
  fiat_p434_mulx_u64(&x477, &x478, x453, UINT64_C(0xffffffffffffffff));
  uint64_t x479;
  uint64_t x480;
  fiat_p434_mulx_u64(&x479, &x480, x453, UINT64_C(0xffffffffffffffff));
  uint64_t x481;
  uint64_t x482;
  fiat_p434_mulx_u64(&x481, &x482, x453, UINT64_C(0xffffffffffffffff));
  uint64_t x483;
  fiat_p434_uint1 x484;
  fiat_p434_addcarryx_u64(&x483, &x484, 0x0, x482, x479);
  uint64_t x485;
  fiat_p434_uint1 x486;
  fiat_p434_addcarryx_u64(&x485, &x486, x484, x480, x477);
  uint64_t x487;
  fiat_p434_uint1 x488;
  fiat_p434_addcarryx_u64(&x487, &x488, x486, x478, x475);
  uint64_t x489;
  fiat_p434_uint1 x490;
  fiat_p434_addcarryx_u64(&x489, &x490, x488, x476, x473);
  uint64_t x491;
  fiat_p434_uint1 x492;
  fiat_p434_addcarryx_u64(&x491, &x492, x490, x474, x471);
  uint64_t x493;
  fiat_p434_uint1 x494;
  fiat_p434_addcarryx_u64(&x493, &x494, x492, x472, x469);
  uint64_t x495 = (x494 + x470);
  uint64_t x496;
  fiat_p434_uint1 x497;
  fiat_p434_addcarryx_u64(&x496, &x497, 0x0, x453, x481);
  uint64_t x498;
  fiat_p434_uint1 x499;
  fiat_p434_addcarryx_u64(&x498, &x499, x497, x455, x483);
  uint64_t x500;
  fiat_p434_uint1 x501;
  fiat_p434_addcarryx_u64(&x500, &x501, x499, x457, x485);
  uint64_t x502;
  fiat_p434_uint1 x503;
  fiat_p434_addcarryx_u64(&x502, &x503, x501, x459, x487);
  uint64_t x504;
  fiat_p434_uint1 x505;
  fiat_p434_addcarryx_u64(&x504, &x505, x503, x461, x489);
  uint64_t x506;
  fiat_p434_uint1 x507;
  fiat_p434_addcarryx_u64(&x506, &x507, x505, x463, x491);
  uint64_t x508;
  fiat_p434_uint1 x509;
  fiat_p434_addcarryx_u64(&x508, &x509, x507, x465, x493);
  uint64_t x510;
  fiat_p434_uint1 x511;
  fiat_p434_addcarryx_u64(&x510, &x511, x509, x467, x495);
  uint64_t x512 = ((uint64_t)x511 + x468);
  uint64_t x513;
  uint64_t x514;
  fiat_p434_mulx_u64(&x513, &x514, x6, (arg2[6]));
  uint64_t x515;
  uint64_t x516;
  fiat_p434_mulx_u64(&x515, &x516, x6, (arg2[5]));
  uint64_t x517;
  uint64_t x518;
  fiat_p434_mulx_u64(&x517, &x518, x6, (arg2[4]));
  uint64_t x519;
  uint64_t x520;
  fiat_p434_mulx_u64(&x519, &x520, x6, (arg2[3]));
  uint64_t x521;
  uint64_t x522;
  fiat_p434_mulx_u64(&x521, &x522, x6, (arg2[2]));
  uint64_t x523;
  uint64_t x524;
  fiat_p434_mulx_u64(&x523, &x524, x6, (arg2[1]));
  uint64_t x525;
  uint64_t x526;
  fiat_p434_mulx_u64(&x525, &x526, x6, (arg2[0]));
  uint64_t x527;
  fiat_p434_uint1 x528;
  fiat_p434_addcarryx_u64(&x527, &x528, 0x0, x526, x523);
  uint64_t x529;
  fiat_p434_uint1 x530;
  fiat_p434_addcarryx_u64(&x529, &x530, x528, x524, x521);
  uint64_t x531;
  fiat_p434_uint1 x532;
  fiat_p434_addcarryx_u64(&x531, &x532, x530, x522, x519);
  uint64_t x533;
  fiat_p434_uint1 x534;
  fiat_p434_addcarryx_u64(&x533, &x534, x532, x520, x517);
  uint64_t x535;
  fiat_p434_uint1 x536;
  fiat_p434_addcarryx_u64(&x535, &x536, x534, x518, x515);
  uint64_t x537;
  fiat_p434_uint1 x538;
  fiat_p434_addcarryx_u64(&x537, &x538, x536, x516, x513);
  uint64_t x539 = (x538 + x514);
  uint64_t x540;
  fiat_p434_uint1 x541;
  fiat_p434_addcarryx_u64(&x540, &x541, 0x0, x498, x525);
  uint64_t x542;
  fiat_p434_uint1 x543;
  fiat_p434_addcarryx_u64(&x542, &x543, x541, x500, x527);
  uint64_t x544;
  fiat_p434_uint1 x545;
  fiat_p434_addcarryx_u64(&x544, &x545, x543, x502, x529);
  uint64_t x546;
  fiat_p434_uint1 x547;
  fiat_p434_addcarryx_u64(&x546, &x547, x545, x504, x531);
  uint64_t x548;
  fiat_p434_uint1 x549;
  fiat_p434_addcarryx_u64(&x548, &x549, x547, x506, x533);
  uint64_t x550;
  fiat_p434_uint1 x551;
  fiat_p434_addcarryx_u64(&x550, &x551, x549, x508, x535);
  uint64_t x552;
  fiat_p434_uint1 x553;
  fiat_p434_addcarryx_u64(&x552, &x553, x551, x510, x537);
  uint64_t x554;
  fiat_p434_uint1 x555;
  fiat_p434_addcarryx_u64(&x554, &x555, x553, x512, x539);
  uint64_t x556;
  uint64_t x557;
  fiat_p434_mulx_u64(&x556, &x557, x540, UINT64_C(0x2341f27177344));
  uint64_t x558;
  uint64_t x559;
  fiat_p434_mulx_u64(&x558, &x559, x540, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x560;
  uint64_t x561;
  fiat_p434_mulx_u64(&x560, &x561, x540, UINT64_C(0x7bc65c783158aea3));
  uint64_t x562;
  uint64_t x563;
  fiat_p434_mulx_u64(&x562, &x563, x540, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x564;
  uint64_t x565;
  fiat_p434_mulx_u64(&x564, &x565, x540, UINT64_C(0xffffffffffffffff));
  uint64_t x566;
  uint64_t x567;
  fiat_p434_mulx_u64(&x566, &x567, x540, UINT64_C(0xffffffffffffffff));
  uint64_t x568;
  uint64_t x569;
  fiat_p434_mulx_u64(&x568, &x569, x540, UINT64_C(0xffffffffffffffff));
  uint64_t x570;
  fiat_p434_uint1 x571;
  fiat_p434_addcarryx_u64(&x570, &x571, 0x0, x569, x566);
  uint64_t x572;
  fiat_p434_uint1 x573;
  fiat_p434_addcarryx_u64(&x572, &x573, x571, x567, x564);
  uint64_t x574;
  fiat_p434_uint1 x575;
  fiat_p434_addcarryx_u64(&x574, &x575, x573, x565, x562);
  uint64_t x576;
  fiat_p434_uint1 x577;
  fiat_p434_addcarryx_u64(&x576, &x577, x575, x563, x560);
  uint64_t x578;
  fiat_p434_uint1 x579;
  fiat_p434_addcarryx_u64(&x578, &x579, x577, x561, x558);
  uint64_t x580;
  fiat_p434_uint1 x581;
  fiat_p434_addcarryx_u64(&x580, &x581, x579, x559, x556);
  uint64_t x582 = (x581 + x557);
  uint64_t x583;
  fiat_p434_uint1 x584;
  fiat_p434_addcarryx_u64(&x583, &x584, 0x0, x540, x568);
  uint64_t x585;
  fiat_p434_uint1 x586;
  fiat_p434_addcarryx_u64(&x585, &x586, x584, x542, x570);
  uint64_t x587;
  fiat_p434_uint1 x588;
  fiat_p434_addcarryx_u64(&x587, &x588, x586, x544, x572);
  uint64_t x589;
  fiat_p434_uint1 x590;
  fiat_p434_addcarryx_u64(&x589, &x590, x588, x546, x574);
  uint64_t x591;
  fiat_p434_uint1 x592;
  fiat_p434_addcarryx_u64(&x591, &x592, x590, x548, x576);
  uint64_t x593;
  fiat_p434_uint1 x594;
  fiat_p434_addcarryx_u64(&x593, &x594, x592, x550, x578);
  uint64_t x595;
  fiat_p434_uint1 x596;
  fiat_p434_addcarryx_u64(&x595, &x596, x594, x552, x580);
  uint64_t x597;
  fiat_p434_uint1 x598;
  fiat_p434_addcarryx_u64(&x597, &x598, x596, x554, x582);
  uint64_t x599 = ((uint64_t)x598 + x555);
  uint64_t x600;
  fiat_p434_uint1 x601;
  fiat_p434_subborrowx_u64(&x600, &x601, 0x0, x585, UINT64_C(0xffffffffffffffff));
  uint64_t x602;
  fiat_p434_uint1 x603;
  fiat_p434_subborrowx_u64(&x602, &x603, x601, x587, UINT64_C(0xffffffffffffffff));
  uint64_t x604;
  fiat_p434_uint1 x605;
  fiat_p434_subborrowx_u64(&x604, &x605, x603, x589, UINT64_C(0xffffffffffffffff));
  uint64_t x606;
  fiat_p434_uint1 x607;
  fiat_p434_subborrowx_u64(&x606, &x607, x605, x591, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x608;
  fiat_p434_uint1 x609;
  fiat_p434_subborrowx_u64(&x608, &x609, x607, x593, UINT64_C(0x7bc65c783158aea3));
  uint64_t x610;
  fiat_p434_uint1 x611;
  fiat_p434_subborrowx_u64(&x610, &x611, x609, x595, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x612;
  fiat_p434_uint1 x613;
  fiat_p434_subborrowx_u64(&x612, &x613, x611, x597, UINT64_C(0x2341f27177344));
  uint64_t x614;
  fiat_p434_uint1 x615;
  fiat_p434_subborrowx_u64(&x614, &x615, x613, x599, 0x0);
  uint64_t x616;
  fiat_p434_cmovznz_u64(&x616, x615, x600, x585);
  uint64_t x617;
  fiat_p434_cmovznz_u64(&x617, x615, x602, x587);
  uint64_t x618;
  fiat_p434_cmovznz_u64(&x618, x615, x604, x589);
  uint64_t x619;
  fiat_p434_cmovznz_u64(&x619, x615, x606, x591);
  uint64_t x620;
  fiat_p434_cmovznz_u64(&x620, x615, x608, x593);
  uint64_t x621;
  fiat_p434_cmovznz_u64(&x621, x615, x610, x595);
  uint64_t x622;
  fiat_p434_cmovznz_u64(&x622, x615, x612, x597);
  out1[0] = x616;
  out1[1] = x617;
  out1[2] = x618;
  out1[3] = x619;
  out1[4] = x620;
  out1[5] = x621;
  out1[6] = x622;
}

/*
 * The function fiat_p434_square squares a field element in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
static void fiat_p434_square(uint64_t out1[7], const uint64_t arg1[7]) {
  uint64_t x1 = (arg1[1]);
  uint64_t x2 = (arg1[2]);
  uint64_t x3 = (arg1[3]);
  uint64_t x4 = (arg1[4]);
  uint64_t x5 = (arg1[5]);
  uint64_t x6 = (arg1[6]);
  uint64_t x7 = (arg1[0]);
  uint64_t x8;
  uint64_t x9;
  fiat_p434_mulx_u64(&x8, &x9, x7, (arg1[6]));
  uint64_t x10;
  uint64_t x11;
  fiat_p434_mulx_u64(&x10, &x11, x7, (arg1[5]));
  uint64_t x12;
  uint64_t x13;
  fiat_p434_mulx_u64(&x12, &x13, x7, (arg1[4]));
  uint64_t x14;
  uint64_t x15;
  fiat_p434_mulx_u64(&x14, &x15, x7, (arg1[3]));
  uint64_t x16;
  uint64_t x17;
  fiat_p434_mulx_u64(&x16, &x17, x7, (arg1[2]));
  uint64_t x18;
  uint64_t x19;
  fiat_p434_mulx_u64(&x18, &x19, x7, (arg1[1]));
  uint64_t x20;
  uint64_t x21;
  fiat_p434_mulx_u64(&x20, &x21, x7, (arg1[0]));
  uint64_t x22;
  fiat_p434_uint1 x23;
  fiat_p434_addcarryx_u64(&x22, &x23, 0x0, x21, x18);
  uint64_t x24;
  fiat_p434_uint1 x25;
  fiat_p434_addcarryx_u64(&x24, &x25, x23, x19, x16);
  uint64_t x26;
  fiat_p434_uint1 x27;
  fiat_p434_addcarryx_u64(&x26, &x27, x25, x17, x14);
  uint64_t x28;
  fiat_p434_uint1 x29;
  fiat_p434_addcarryx_u64(&x28, &x29, x27, x15, x12);
  uint64_t x30;
  fiat_p434_uint1 x31;
  fiat_p434_addcarryx_u64(&x30, &x31, x29, x13, x10);
  uint64_t x32;
  fiat_p434_uint1 x33;
  fiat_p434_addcarryx_u64(&x32, &x33, x31, x11, x8);
  uint64_t x34 = (x33 + x9);
  uint64_t x35;
  uint64_t x36;
  fiat_p434_mulx_u64(&x35, &x36, x20, UINT64_C(0x2341f27177344));
  uint64_t x37;
  uint64_t x38;
  fiat_p434_mulx_u64(&x37, &x38, x20, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x39;
  uint64_t x40;
  fiat_p434_mulx_u64(&x39, &x40, x20, UINT64_C(0x7bc65c783158aea3));
  uint64_t x41;
  uint64_t x42;
  fiat_p434_mulx_u64(&x41, &x42, x20, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x43;
  uint64_t x44;
  fiat_p434_mulx_u64(&x43, &x44, x20, UINT64_C(0xffffffffffffffff));
  uint64_t x45;
  uint64_t x46;
  fiat_p434_mulx_u64(&x45, &x46, x20, UINT64_C(0xffffffffffffffff));
  uint64_t x47;
  uint64_t x48;
  fiat_p434_mulx_u64(&x47, &x48, x20, UINT64_C(0xffffffffffffffff));
  uint64_t x49;
  fiat_p434_uint1 x50;
  fiat_p434_addcarryx_u64(&x49, &x50, 0x0, x48, x45);
  uint64_t x51;
  fiat_p434_uint1 x52;
  fiat_p434_addcarryx_u64(&x51, &x52, x50, x46, x43);
  uint64_t x53;
  fiat_p434_uint1 x54;
  fiat_p434_addcarryx_u64(&x53, &x54, x52, x44, x41);
  uint64_t x55;
  fiat_p434_uint1 x56;
  fiat_p434_addcarryx_u64(&x55, &x56, x54, x42, x39);
  uint64_t x57;
  fiat_p434_uint1 x58;
  fiat_p434_addcarryx_u64(&x57, &x58, x56, x40, x37);
  uint64_t x59;
  fiat_p434_uint1 x60;
  fiat_p434_addcarryx_u64(&x59, &x60, x58, x38, x35);
  uint64_t x61 = (x60 + x36);
  uint64_t x62;
  fiat_p434_uint1 x63;
  fiat_p434_addcarryx_u64(&x62, &x63, 0x0, x20, x47);
  uint64_t x64;
  fiat_p434_uint1 x65;
  fiat_p434_addcarryx_u64(&x64, &x65, x63, x22, x49);
  uint64_t x66;
  fiat_p434_uint1 x67;
  fiat_p434_addcarryx_u64(&x66, &x67, x65, x24, x51);
  uint64_t x68;
  fiat_p434_uint1 x69;
  fiat_p434_addcarryx_u64(&x68, &x69, x67, x26, x53);
  uint64_t x70;
  fiat_p434_uint1 x71;
  fiat_p434_addcarryx_u64(&x70, &x71, x69, x28, x55);
  uint64_t x72;
  fiat_p434_uint1 x73;
  fiat_p434_addcarryx_u64(&x72, &x73, x71, x30, x57);
  uint64_t x74;
  fiat_p434_uint1 x75;
  fiat_p434_addcarryx_u64(&x74, &x75, x73, x32, x59);
  uint64_t x76;
  fiat_p434_uint1 x77;
  fiat_p434_addcarryx_u64(&x76, &x77, x75, x34, x61);
  uint64_t x78;
  uint64_t x79;
  fiat_p434_mulx_u64(&x78, &x79, x1, (arg1[6]));
  uint64_t x80;
  uint64_t x81;
  fiat_p434_mulx_u64(&x80, &x81, x1, (arg1[5]));
  uint64_t x82;
  uint64_t x83;
  fiat_p434_mulx_u64(&x82, &x83, x1, (arg1[4]));
  uint64_t x84;
  uint64_t x85;
  fiat_p434_mulx_u64(&x84, &x85, x1, (arg1[3]));
  uint64_t x86;
  uint64_t x87;
  fiat_p434_mulx_u64(&x86, &x87, x1, (arg1[2]));
  uint64_t x88;
  uint64_t x89;
  fiat_p434_mulx_u64(&x88, &x89, x1, (arg1[1]));
  uint64_t x90;
  uint64_t x91;
  fiat_p434_mulx_u64(&x90, &x91, x1, (arg1[0]));
  uint64_t x92;
  fiat_p434_uint1 x93;
  fiat_p434_addcarryx_u64(&x92, &x93, 0x0, x91, x88);
  uint64_t x94;
  fiat_p434_uint1 x95;
  fiat_p434_addcarryx_u64(&x94, &x95, x93, x89, x86);
  uint64_t x96;
  fiat_p434_uint1 x97;
  fiat_p434_addcarryx_u64(&x96, &x97, x95, x87, x84);
  uint64_t x98;
  fiat_p434_uint1 x99;
  fiat_p434_addcarryx_u64(&x98, &x99, x97, x85, x82);
  uint64_t x100;
  fiat_p434_uint1 x101;
  fiat_p434_addcarryx_u64(&x100, &x101, x99, x83, x80);
  uint64_t x102;
  fiat_p434_uint1 x103;
  fiat_p434_addcarryx_u64(&x102, &x103, x101, x81, x78);
  uint64_t x104 = (x103 + x79);
  uint64_t x105;
  fiat_p434_uint1 x106;
  fiat_p434_addcarryx_u64(&x105, &x106, 0x0, x64, x90);
  uint64_t x107;
  fiat_p434_uint1 x108;
  fiat_p434_addcarryx_u64(&x107, &x108, x106, x66, x92);
  uint64_t x109;
  fiat_p434_uint1 x110;
  fiat_p434_addcarryx_u64(&x109, &x110, x108, x68, x94);
  uint64_t x111;
  fiat_p434_uint1 x112;
  fiat_p434_addcarryx_u64(&x111, &x112, x110, x70, x96);
  uint64_t x113;
  fiat_p434_uint1 x114;
  fiat_p434_addcarryx_u64(&x113, &x114, x112, x72, x98);
  uint64_t x115;
  fiat_p434_uint1 x116;
  fiat_p434_addcarryx_u64(&x115, &x116, x114, x74, x100);
  uint64_t x117;
  fiat_p434_uint1 x118;
  fiat_p434_addcarryx_u64(&x117, &x118, x116, x76, x102);
  uint64_t x119;
  fiat_p434_uint1 x120;
  fiat_p434_addcarryx_u64(&x119, &x120, x118, x77, x104);
  uint64_t x121;
  uint64_t x122;
  fiat_p434_mulx_u64(&x121, &x122, x105, UINT64_C(0x2341f27177344));
  uint64_t x123;
  uint64_t x124;
  fiat_p434_mulx_u64(&x123, &x124, x105, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x125;
  uint64_t x126;
  fiat_p434_mulx_u64(&x125, &x126, x105, UINT64_C(0x7bc65c783158aea3));
  uint64_t x127;
  uint64_t x128;
  fiat_p434_mulx_u64(&x127, &x128, x105, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x129;
  uint64_t x130;
  fiat_p434_mulx_u64(&x129, &x130, x105, UINT64_C(0xffffffffffffffff));
  uint64_t x131;
  uint64_t x132;
  fiat_p434_mulx_u64(&x131, &x132, x105, UINT64_C(0xffffffffffffffff));
  uint64_t x133;
  uint64_t x134;
  fiat_p434_mulx_u64(&x133, &x134, x105, UINT64_C(0xffffffffffffffff));
  uint64_t x135;
  fiat_p434_uint1 x136;
  fiat_p434_addcarryx_u64(&x135, &x136, 0x0, x134, x131);
  uint64_t x137;
  fiat_p434_uint1 x138;
  fiat_p434_addcarryx_u64(&x137, &x138, x136, x132, x129);
  uint64_t x139;
  fiat_p434_uint1 x140;
  fiat_p434_addcarryx_u64(&x139, &x140, x138, x130, x127);
  uint64_t x141;
  fiat_p434_uint1 x142;
  fiat_p434_addcarryx_u64(&x141, &x142, x140, x128, x125);
  uint64_t x143;
  fiat_p434_uint1 x144;
  fiat_p434_addcarryx_u64(&x143, &x144, x142, x126, x123);
  uint64_t x145;
  fiat_p434_uint1 x146;
  fiat_p434_addcarryx_u64(&x145, &x146, x144, x124, x121);
  uint64_t x147 = (x146 + x122);
  uint64_t x148;
  fiat_p434_uint1 x149;
  fiat_p434_addcarryx_u64(&x148, &x149, 0x0, x105, x133);
  uint64_t x150;
  fiat_p434_uint1 x151;
  fiat_p434_addcarryx_u64(&x150, &x151, x149, x107, x135);
  uint64_t x152;
  fiat_p434_uint1 x153;
  fiat_p434_addcarryx_u64(&x152, &x153, x151, x109, x137);
  uint64_t x154;
  fiat_p434_uint1 x155;
  fiat_p434_addcarryx_u64(&x154, &x155, x153, x111, x139);
  uint64_t x156;
  fiat_p434_uint1 x157;
  fiat_p434_addcarryx_u64(&x156, &x157, x155, x113, x141);
  uint64_t x158;
  fiat_p434_uint1 x159;
  fiat_p434_addcarryx_u64(&x158, &x159, x157, x115, x143);
  uint64_t x160;
  fiat_p434_uint1 x161;
  fiat_p434_addcarryx_u64(&x160, &x161, x159, x117, x145);
  uint64_t x162;
  fiat_p434_uint1 x163;
  fiat_p434_addcarryx_u64(&x162, &x163, x161, x119, x147);
  uint64_t x164 = ((uint64_t)x163 + x120);
  uint64_t x165;
  uint64_t x166;
  fiat_p434_mulx_u64(&x165, &x166, x2, (arg1[6]));
  uint64_t x167;
  uint64_t x168;
  fiat_p434_mulx_u64(&x167, &x168, x2, (arg1[5]));
  uint64_t x169;
  uint64_t x170;
  fiat_p434_mulx_u64(&x169, &x170, x2, (arg1[4]));
  uint64_t x171;
  uint64_t x172;
  fiat_p434_mulx_u64(&x171, &x172, x2, (arg1[3]));
  uint64_t x173;
  uint64_t x174;
  fiat_p434_mulx_u64(&x173, &x174, x2, (arg1[2]));
  uint64_t x175;
  uint64_t x176;
  fiat_p434_mulx_u64(&x175, &x176, x2, (arg1[1]));
  uint64_t x177;
  uint64_t x178;
  fiat_p434_mulx_u64(&x177, &x178, x2, (arg1[0]));
  uint64_t x179;
  fiat_p434_uint1 x180;
  fiat_p434_addcarryx_u64(&x179, &x180, 0x0, x178, x175);
  uint64_t x181;
  fiat_p434_uint1 x182;
  fiat_p434_addcarryx_u64(&x181, &x182, x180, x176, x173);
  uint64_t x183;
  fiat_p434_uint1 x184;
  fiat_p434_addcarryx_u64(&x183, &x184, x182, x174, x171);
  uint64_t x185;
  fiat_p434_uint1 x186;
  fiat_p434_addcarryx_u64(&x185, &x186, x184, x172, x169);
  uint64_t x187;
  fiat_p434_uint1 x188;
  fiat_p434_addcarryx_u64(&x187, &x188, x186, x170, x167);
  uint64_t x189;
  fiat_p434_uint1 x190;
  fiat_p434_addcarryx_u64(&x189, &x190, x188, x168, x165);
  uint64_t x191 = (x190 + x166);
  uint64_t x192;
  fiat_p434_uint1 x193;
  fiat_p434_addcarryx_u64(&x192, &x193, 0x0, x150, x177);
  uint64_t x194;
  fiat_p434_uint1 x195;
  fiat_p434_addcarryx_u64(&x194, &x195, x193, x152, x179);
  uint64_t x196;
  fiat_p434_uint1 x197;
  fiat_p434_addcarryx_u64(&x196, &x197, x195, x154, x181);
  uint64_t x198;
  fiat_p434_uint1 x199;
  fiat_p434_addcarryx_u64(&x198, &x199, x197, x156, x183);
  uint64_t x200;
  fiat_p434_uint1 x201;
  fiat_p434_addcarryx_u64(&x200, &x201, x199, x158, x185);
  uint64_t x202;
  fiat_p434_uint1 x203;
  fiat_p434_addcarryx_u64(&x202, &x203, x201, x160, x187);
  uint64_t x204;
  fiat_p434_uint1 x205;
  fiat_p434_addcarryx_u64(&x204, &x205, x203, x162, x189);
  uint64_t x206;
  fiat_p434_uint1 x207;
  fiat_p434_addcarryx_u64(&x206, &x207, x205, x164, x191);
  uint64_t x208;
  uint64_t x209;
  fiat_p434_mulx_u64(&x208, &x209, x192, UINT64_C(0x2341f27177344));
  uint64_t x210;
  uint64_t x211;
  fiat_p434_mulx_u64(&x210, &x211, x192, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x212;
  uint64_t x213;
  fiat_p434_mulx_u64(&x212, &x213, x192, UINT64_C(0x7bc65c783158aea3));
  uint64_t x214;
  uint64_t x215;
  fiat_p434_mulx_u64(&x214, &x215, x192, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x216;
  uint64_t x217;
  fiat_p434_mulx_u64(&x216, &x217, x192, UINT64_C(0xffffffffffffffff));
  uint64_t x218;
  uint64_t x219;
  fiat_p434_mulx_u64(&x218, &x219, x192, UINT64_C(0xffffffffffffffff));
  uint64_t x220;
  uint64_t x221;
  fiat_p434_mulx_u64(&x220, &x221, x192, UINT64_C(0xffffffffffffffff));
  uint64_t x222;
  fiat_p434_uint1 x223;
  fiat_p434_addcarryx_u64(&x222, &x223, 0x0, x221, x218);
  uint64_t x224;
  fiat_p434_uint1 x225;
  fiat_p434_addcarryx_u64(&x224, &x225, x223, x219, x216);
  uint64_t x226;
  fiat_p434_uint1 x227;
  fiat_p434_addcarryx_u64(&x226, &x227, x225, x217, x214);
  uint64_t x228;
  fiat_p434_uint1 x229;
  fiat_p434_addcarryx_u64(&x228, &x229, x227, x215, x212);
  uint64_t x230;
  fiat_p434_uint1 x231;
  fiat_p434_addcarryx_u64(&x230, &x231, x229, x213, x210);
  uint64_t x232;
  fiat_p434_uint1 x233;
  fiat_p434_addcarryx_u64(&x232, &x233, x231, x211, x208);
  uint64_t x234 = (x233 + x209);
  uint64_t x235;
  fiat_p434_uint1 x236;
  fiat_p434_addcarryx_u64(&x235, &x236, 0x0, x192, x220);
  uint64_t x237;
  fiat_p434_uint1 x238;
  fiat_p434_addcarryx_u64(&x237, &x238, x236, x194, x222);
  uint64_t x239;
  fiat_p434_uint1 x240;
  fiat_p434_addcarryx_u64(&x239, &x240, x238, x196, x224);
  uint64_t x241;
  fiat_p434_uint1 x242;
  fiat_p434_addcarryx_u64(&x241, &x242, x240, x198, x226);
  uint64_t x243;
  fiat_p434_uint1 x244;
  fiat_p434_addcarryx_u64(&x243, &x244, x242, x200, x228);
  uint64_t x245;
  fiat_p434_uint1 x246;
  fiat_p434_addcarryx_u64(&x245, &x246, x244, x202, x230);
  uint64_t x247;
  fiat_p434_uint1 x248;
  fiat_p434_addcarryx_u64(&x247, &x248, x246, x204, x232);
  uint64_t x249;
  fiat_p434_uint1 x250;
  fiat_p434_addcarryx_u64(&x249, &x250, x248, x206, x234);
  uint64_t x251 = ((uint64_t)x250 + x207);
  uint64_t x252;
  uint64_t x253;
  fiat_p434_mulx_u64(&x252, &x253, x3, (arg1[6]));
  uint64_t x254;
  uint64_t x255;
  fiat_p434_mulx_u64(&x254, &x255, x3, (arg1[5]));
  uint64_t x256;
  uint64_t x257;
  fiat_p434_mulx_u64(&x256, &x257, x3, (arg1[4]));
  uint64_t x258;
  uint64_t x259;
  fiat_p434_mulx_u64(&x258, &x259, x3, (arg1[3]));
  uint64_t x260;
  uint64_t x261;
  fiat_p434_mulx_u64(&x260, &x261, x3, (arg1[2]));
  uint64_t x262;
  uint64_t x263;
  fiat_p434_mulx_u64(&x262, &x263, x3, (arg1[1]));
  uint64_t x264;
  uint64_t x265;
  fiat_p434_mulx_u64(&x264, &x265, x3, (arg1[0]));
  uint64_t x266;
  fiat_p434_uint1 x267;
  fiat_p434_addcarryx_u64(&x266, &x267, 0x0, x265, x262);
  uint64_t x268;
  fiat_p434_uint1 x269;
  fiat_p434_addcarryx_u64(&x268, &x269, x267, x263, x260);
  uint64_t x270;
  fiat_p434_uint1 x271;
  fiat_p434_addcarryx_u64(&x270, &x271, x269, x261, x258);
  uint64_t x272;
  fiat_p434_uint1 x273;
  fiat_p434_addcarryx_u64(&x272, &x273, x271, x259, x256);
  uint64_t x274;
  fiat_p434_uint1 x275;
  fiat_p434_addcarryx_u64(&x274, &x275, x273, x257, x254);
  uint64_t x276;
  fiat_p434_uint1 x277;
  fiat_p434_addcarryx_u64(&x276, &x277, x275, x255, x252);
  uint64_t x278 = (x277 + x253);
  uint64_t x279;
  fiat_p434_uint1 x280;
  fiat_p434_addcarryx_u64(&x279, &x280, 0x0, x237, x264);
  uint64_t x281;
  fiat_p434_uint1 x282;
  fiat_p434_addcarryx_u64(&x281, &x282, x280, x239, x266);
  uint64_t x283;
  fiat_p434_uint1 x284;
  fiat_p434_addcarryx_u64(&x283, &x284, x282, x241, x268);
  uint64_t x285;
  fiat_p434_uint1 x286;
  fiat_p434_addcarryx_u64(&x285, &x286, x284, x243, x270);
  uint64_t x287;
  fiat_p434_uint1 x288;
  fiat_p434_addcarryx_u64(&x287, &x288, x286, x245, x272);
  uint64_t x289;
  fiat_p434_uint1 x290;
  fiat_p434_addcarryx_u64(&x289, &x290, x288, x247, x274);
  uint64_t x291;
  fiat_p434_uint1 x292;
  fiat_p434_addcarryx_u64(&x291, &x292, x290, x249, x276);
  uint64_t x293;
  fiat_p434_uint1 x294;
  fiat_p434_addcarryx_u64(&x293, &x294, x292, x251, x278);
  uint64_t x295;
  uint64_t x296;
  fiat_p434_mulx_u64(&x295, &x296, x279, UINT64_C(0x2341f27177344));
  uint64_t x297;
  uint64_t x298;
  fiat_p434_mulx_u64(&x297, &x298, x279, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x299;
  uint64_t x300;
  fiat_p434_mulx_u64(&x299, &x300, x279, UINT64_C(0x7bc65c783158aea3));
  uint64_t x301;
  uint64_t x302;
  fiat_p434_mulx_u64(&x301, &x302, x279, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x303;
  uint64_t x304;
  fiat_p434_mulx_u64(&x303, &x304, x279, UINT64_C(0xffffffffffffffff));
  uint64_t x305;
  uint64_t x306;
  fiat_p434_mulx_u64(&x305, &x306, x279, UINT64_C(0xffffffffffffffff));
  uint64_t x307;
  uint64_t x308;
  fiat_p434_mulx_u64(&x307, &x308, x279, UINT64_C(0xffffffffffffffff));
  uint64_t x309;
  fiat_p434_uint1 x310;
  fiat_p434_addcarryx_u64(&x309, &x310, 0x0, x308, x305);
  uint64_t x311;
  fiat_p434_uint1 x312;
  fiat_p434_addcarryx_u64(&x311, &x312, x310, x306, x303);
  uint64_t x313;
  fiat_p434_uint1 x314;
  fiat_p434_addcarryx_u64(&x313, &x314, x312, x304, x301);
  uint64_t x315;
  fiat_p434_uint1 x316;
  fiat_p434_addcarryx_u64(&x315, &x316, x314, x302, x299);
  uint64_t x317;
  fiat_p434_uint1 x318;
  fiat_p434_addcarryx_u64(&x317, &x318, x316, x300, x297);
  uint64_t x319;
  fiat_p434_uint1 x320;
  fiat_p434_addcarryx_u64(&x319, &x320, x318, x298, x295);
  uint64_t x321 = (x320 + x296);
  uint64_t x322;
  fiat_p434_uint1 x323;
  fiat_p434_addcarryx_u64(&x322, &x323, 0x0, x279, x307);
  uint64_t x324;
  fiat_p434_uint1 x325;
  fiat_p434_addcarryx_u64(&x324, &x325, x323, x281, x309);
  uint64_t x326;
  fiat_p434_uint1 x327;
  fiat_p434_addcarryx_u64(&x326, &x327, x325, x283, x311);
  uint64_t x328;
  fiat_p434_uint1 x329;
  fiat_p434_addcarryx_u64(&x328, &x329, x327, x285, x313);
  uint64_t x330;
  fiat_p434_uint1 x331;
  fiat_p434_addcarryx_u64(&x330, &x331, x329, x287, x315);
  uint64_t x332;
  fiat_p434_uint1 x333;
  fiat_p434_addcarryx_u64(&x332, &x333, x331, x289, x317);
  uint64_t x334;
  fiat_p434_uint1 x335;
  fiat_p434_addcarryx_u64(&x334, &x335, x333, x291, x319);
  uint64_t x336;
  fiat_p434_uint1 x337;
  fiat_p434_addcarryx_u64(&x336, &x337, x335, x293, x321);
  uint64_t x338 = ((uint64_t)x337 + x294);
  uint64_t x339;
  uint64_t x340;
  fiat_p434_mulx_u64(&x339, &x340, x4, (arg1[6]));
  uint64_t x341;
  uint64_t x342;
  fiat_p434_mulx_u64(&x341, &x342, x4, (arg1[5]));
  uint64_t x343;
  uint64_t x344;
  fiat_p434_mulx_u64(&x343, &x344, x4, (arg1[4]));
  uint64_t x345;
  uint64_t x346;
  fiat_p434_mulx_u64(&x345, &x346, x4, (arg1[3]));
  uint64_t x347;
  uint64_t x348;
  fiat_p434_mulx_u64(&x347, &x348, x4, (arg1[2]));
  uint64_t x349;
  uint64_t x350;
  fiat_p434_mulx_u64(&x349, &x350, x4, (arg1[1]));
  uint64_t x351;
  uint64_t x352;
  fiat_p434_mulx_u64(&x351, &x352, x4, (arg1[0]));
  uint64_t x353;
  fiat_p434_uint1 x354;
  fiat_p434_addcarryx_u64(&x353, &x354, 0x0, x352, x349);
  uint64_t x355;
  fiat_p434_uint1 x356;
  fiat_p434_addcarryx_u64(&x355, &x356, x354, x350, x347);
  uint64_t x357;
  fiat_p434_uint1 x358;
  fiat_p434_addcarryx_u64(&x357, &x358, x356, x348, x345);
  uint64_t x359;
  fiat_p434_uint1 x360;
  fiat_p434_addcarryx_u64(&x359, &x360, x358, x346, x343);
  uint64_t x361;
  fiat_p434_uint1 x362;
  fiat_p434_addcarryx_u64(&x361, &x362, x360, x344, x341);
  uint64_t x363;
  fiat_p434_uint1 x364;
  fiat_p434_addcarryx_u64(&x363, &x364, x362, x342, x339);
  uint64_t x365 = (x364 + x340);
  uint64_t x366;
  fiat_p434_uint1 x367;
  fiat_p434_addcarryx_u64(&x366, &x367, 0x0, x324, x351);
  uint64_t x368;
  fiat_p434_uint1 x369;
  fiat_p434_addcarryx_u64(&x368, &x369, x367, x326, x353);
  uint64_t x370;
  fiat_p434_uint1 x371;
  fiat_p434_addcarryx_u64(&x370, &x371, x369, x328, x355);
  uint64_t x372;
  fiat_p434_uint1 x373;
  fiat_p434_addcarryx_u64(&x372, &x373, x371, x330, x357);
  uint64_t x374;
  fiat_p434_uint1 x375;
  fiat_p434_addcarryx_u64(&x374, &x375, x373, x332, x359);
  uint64_t x376;
  fiat_p434_uint1 x377;
  fiat_p434_addcarryx_u64(&x376, &x377, x375, x334, x361);
  uint64_t x378;
  fiat_p434_uint1 x379;
  fiat_p434_addcarryx_u64(&x378, &x379, x377, x336, x363);
  uint64_t x380;
  fiat_p434_uint1 x381;
  fiat_p434_addcarryx_u64(&x380, &x381, x379, x338, x365);
  uint64_t x382;
  uint64_t x383;
  fiat_p434_mulx_u64(&x382, &x383, x366, UINT64_C(0x2341f27177344));
  uint64_t x384;
  uint64_t x385;
  fiat_p434_mulx_u64(&x384, &x385, x366, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x386;
  uint64_t x387;
  fiat_p434_mulx_u64(&x386, &x387, x366, UINT64_C(0x7bc65c783158aea3));
  uint64_t x388;
  uint64_t x389;
  fiat_p434_mulx_u64(&x388, &x389, x366, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x390;
  uint64_t x391;
  fiat_p434_mulx_u64(&x390, &x391, x366, UINT64_C(0xffffffffffffffff));
  uint64_t x392;
  uint64_t x393;
  fiat_p434_mulx_u64(&x392, &x393, x366, UINT64_C(0xffffffffffffffff));
  uint64_t x394;
  uint64_t x395;
  fiat_p434_mulx_u64(&x394, &x395, x366, UINT64_C(0xffffffffffffffff));
  uint64_t x396;
  fiat_p434_uint1 x397;
  fiat_p434_addcarryx_u64(&x396, &x397, 0x0, x395, x392);
  uint64_t x398;
  fiat_p434_uint1 x399;
  fiat_p434_addcarryx_u64(&x398, &x399, x397, x393, x390);
  uint64_t x400;
  fiat_p434_uint1 x401;
  fiat_p434_addcarryx_u64(&x400, &x401, x399, x391, x388);
  uint64_t x402;
  fiat_p434_uint1 x403;
  fiat_p434_addcarryx_u64(&x402, &x403, x401, x389, x386);
  uint64_t x404;
  fiat_p434_uint1 x405;
  fiat_p434_addcarryx_u64(&x404, &x405, x403, x387, x384);
  uint64_t x406;
  fiat_p434_uint1 x407;
  fiat_p434_addcarryx_u64(&x406, &x407, x405, x385, x382);
  uint64_t x408 = (x407 + x383);
  uint64_t x409;
  fiat_p434_uint1 x410;
  fiat_p434_addcarryx_u64(&x409, &x410, 0x0, x366, x394);
  uint64_t x411;
  fiat_p434_uint1 x412;
  fiat_p434_addcarryx_u64(&x411, &x412, x410, x368, x396);
  uint64_t x413;
  fiat_p434_uint1 x414;
  fiat_p434_addcarryx_u64(&x413, &x414, x412, x370, x398);
  uint64_t x415;
  fiat_p434_uint1 x416;
  fiat_p434_addcarryx_u64(&x415, &x416, x414, x372, x400);
  uint64_t x417;
  fiat_p434_uint1 x418;
  fiat_p434_addcarryx_u64(&x417, &x418, x416, x374, x402);
  uint64_t x419;
  fiat_p434_uint1 x420;
  fiat_p434_addcarryx_u64(&x419, &x420, x418, x376, x404);
  uint64_t x421;
  fiat_p434_uint1 x422;
  fiat_p434_addcarryx_u64(&x421, &x422, x420, x378, x406);
  uint64_t x423;
  fiat_p434_uint1 x424;
  fiat_p434_addcarryx_u64(&x423, &x424, x422, x380, x408);
  uint64_t x425 = ((uint64_t)x424 + x381);
  uint64_t x426;
  uint64_t x427;
  fiat_p434_mulx_u64(&x426, &x427, x5, (arg1[6]));
  uint64_t x428;
  uint64_t x429;
  fiat_p434_mulx_u64(&x428, &x429, x5, (arg1[5]));
  uint64_t x430;
  uint64_t x431;
  fiat_p434_mulx_u64(&x430, &x431, x5, (arg1[4]));
  uint64_t x432;
  uint64_t x433;
  fiat_p434_mulx_u64(&x432, &x433, x5, (arg1[3]));
  uint64_t x434;
  uint64_t x435;
  fiat_p434_mulx_u64(&x434, &x435, x5, (arg1[2]));
  uint64_t x436;
  uint64_t x437;
  fiat_p434_mulx_u64(&x436, &x437, x5, (arg1[1]));
  uint64_t x438;
  uint64_t x439;
  fiat_p434_mulx_u64(&x438, &x439, x5, (arg1[0]));
  uint64_t x440;
  fiat_p434_uint1 x441;
  fiat_p434_addcarryx_u64(&x440, &x441, 0x0, x439, x436);
  uint64_t x442;
  fiat_p434_uint1 x443;
  fiat_p434_addcarryx_u64(&x442, &x443, x441, x437, x434);
  uint64_t x444;
  fiat_p434_uint1 x445;
  fiat_p434_addcarryx_u64(&x444, &x445, x443, x435, x432);
  uint64_t x446;
  fiat_p434_uint1 x447;
  fiat_p434_addcarryx_u64(&x446, &x447, x445, x433, x430);
  uint64_t x448;
  fiat_p434_uint1 x449;
  fiat_p434_addcarryx_u64(&x448, &x449, x447, x431, x428);
  uint64_t x450;
  fiat_p434_uint1 x451;
  fiat_p434_addcarryx_u64(&x450, &x451, x449, x429, x426);
  uint64_t x452 = (x451 + x427);
  uint64_t x453;
  fiat_p434_uint1 x454;
  fiat_p434_addcarryx_u64(&x453, &x454, 0x0, x411, x438);
  uint64_t x455;
  fiat_p434_uint1 x456;
  fiat_p434_addcarryx_u64(&x455, &x456, x454, x413, x440);
  uint64_t x457;
  fiat_p434_uint1 x458;
  fiat_p434_addcarryx_u64(&x457, &x458, x456, x415, x442);
  uint64_t x459;
  fiat_p434_uint1 x460;
  fiat_p434_addcarryx_u64(&x459, &x460, x458, x417, x444);
  uint64_t x461;
  fiat_p434_uint1 x462;
  fiat_p434_addcarryx_u64(&x461, &x462, x460, x419, x446);
  uint64_t x463;
  fiat_p434_uint1 x464;
  fiat_p434_addcarryx_u64(&x463, &x464, x462, x421, x448);
  uint64_t x465;
  fiat_p434_uint1 x466;
  fiat_p434_addcarryx_u64(&x465, &x466, x464, x423, x450);
  uint64_t x467;
  fiat_p434_uint1 x468;
  fiat_p434_addcarryx_u64(&x467, &x468, x466, x425, x452);
  uint64_t x469;
  uint64_t x470;
  fiat_p434_mulx_u64(&x469, &x470, x453, UINT64_C(0x2341f27177344));
  uint64_t x471;
  uint64_t x472;
  fiat_p434_mulx_u64(&x471, &x472, x453, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x473;
  uint64_t x474;
  fiat_p434_mulx_u64(&x473, &x474, x453, UINT64_C(0x7bc65c783158aea3));
  uint64_t x475;
  uint64_t x476;
  fiat_p434_mulx_u64(&x475, &x476, x453, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x477;
  uint64_t x478;
  fiat_p434_mulx_u64(&x477, &x478, x453, UINT64_C(0xffffffffffffffff));
  uint64_t x479;
  uint64_t x480;
  fiat_p434_mulx_u64(&x479, &x480, x453, UINT64_C(0xffffffffffffffff));
  uint64_t x481;
  uint64_t x482;
  fiat_p434_mulx_u64(&x481, &x482, x453, UINT64_C(0xffffffffffffffff));
  uint64_t x483;
  fiat_p434_uint1 x484;
  fiat_p434_addcarryx_u64(&x483, &x484, 0x0, x482, x479);
  uint64_t x485;
  fiat_p434_uint1 x486;
  fiat_p434_addcarryx_u64(&x485, &x486, x484, x480, x477);
  uint64_t x487;
  fiat_p434_uint1 x488;
  fiat_p434_addcarryx_u64(&x487, &x488, x486, x478, x475);
  uint64_t x489;
  fiat_p434_uint1 x490;
  fiat_p434_addcarryx_u64(&x489, &x490, x488, x476, x473);
  uint64_t x491;
  fiat_p434_uint1 x492;
  fiat_p434_addcarryx_u64(&x491, &x492, x490, x474, x471);
  uint64_t x493;
  fiat_p434_uint1 x494;
  fiat_p434_addcarryx_u64(&x493, &x494, x492, x472, x469);
  uint64_t x495 = (x494 + x470);
  uint64_t x496;
  fiat_p434_uint1 x497;
  fiat_p434_addcarryx_u64(&x496, &x497, 0x0, x453, x481);
  uint64_t x498;
  fiat_p434_uint1 x499;
  fiat_p434_addcarryx_u64(&x498, &x499, x497, x455, x483);
  uint64_t x500;
  fiat_p434_uint1 x501;
  fiat_p434_addcarryx_u64(&x500, &x501, x499, x457, x485);
  uint64_t x502;
  fiat_p434_uint1 x503;
  fiat_p434_addcarryx_u64(&x502, &x503, x501, x459, x487);
  uint64_t x504;
  fiat_p434_uint1 x505;
  fiat_p434_addcarryx_u64(&x504, &x505, x503, x461, x489);
  uint64_t x506;
  fiat_p434_uint1 x507;
  fiat_p434_addcarryx_u64(&x506, &x507, x505, x463, x491);
  uint64_t x508;
  fiat_p434_uint1 x509;
  fiat_p434_addcarryx_u64(&x508, &x509, x507, x465, x493);
  uint64_t x510;
  fiat_p434_uint1 x511;
  fiat_p434_addcarryx_u64(&x510, &x511, x509, x467, x495);
  uint64_t x512 = ((uint64_t)x511 + x468);
  uint64_t x513;
  uint64_t x514;
  fiat_p434_mulx_u64(&x513, &x514, x6, (arg1[6]));
  uint64_t x515;
  uint64_t x516;
  fiat_p434_mulx_u64(&x515, &x516, x6, (arg1[5]));
  uint64_t x517;
  uint64_t x518;
  fiat_p434_mulx_u64(&x517, &x518, x6, (arg1[4]));
  uint64_t x519;
  uint64_t x520;
  fiat_p434_mulx_u64(&x519, &x520, x6, (arg1[3]));
  uint64_t x521;
  uint64_t x522;
  fiat_p434_mulx_u64(&x521, &x522, x6, (arg1[2]));
  uint64_t x523;
  uint64_t x524;
  fiat_p434_mulx_u64(&x523, &x524, x6, (arg1[1]));
  uint64_t x525;
  uint64_t x526;
  fiat_p434_mulx_u64(&x525, &x526, x6, (arg1[0]));
  uint64_t x527;
  fiat_p434_uint1 x528;
  fiat_p434_addcarryx_u64(&x527, &x528, 0x0, x526, x523);
  uint64_t x529;
  fiat_p434_uint1 x530;
  fiat_p434_addcarryx_u64(&x529, &x530, x528, x524, x521);
  uint64_t x531;
  fiat_p434_uint1 x532;
  fiat_p434_addcarryx_u64(&x531, &x532, x530, x522, x519);
  uint64_t x533;
  fiat_p434_uint1 x534;
  fiat_p434_addcarryx_u64(&x533, &x534, x532, x520, x517);
  uint64_t x535;
  fiat_p434_uint1 x536;
  fiat_p434_addcarryx_u64(&x535, &x536, x534, x518, x515);
  uint64_t x537;
  fiat_p434_uint1 x538;
  fiat_p434_addcarryx_u64(&x537, &x538, x536, x516, x513);
  uint64_t x539 = (x538 + x514);
  uint64_t x540;
  fiat_p434_uint1 x541;
  fiat_p434_addcarryx_u64(&x540, &x541, 0x0, x498, x525);
  uint64_t x542;
  fiat_p434_uint1 x543;
  fiat_p434_addcarryx_u64(&x542, &x543, x541, x500, x527);
  uint64_t x544;
  fiat_p434_uint1 x545;
  fiat_p434_addcarryx_u64(&x544, &x545, x543, x502, x529);
  uint64_t x546;
  fiat_p434_uint1 x547;
  fiat_p434_addcarryx_u64(&x546, &x547, x545, x504, x531);
  uint64_t x548;
  fiat_p434_uint1 x549;
  fiat_p434_addcarryx_u64(&x548, &x549, x547, x506, x533);
  uint64_t x550;
  fiat_p434_uint1 x551;
  fiat_p434_addcarryx_u64(&x550, &x551, x549, x508, x535);
  uint64_t x552;
  fiat_p434_uint1 x553;
  fiat_p434_addcarryx_u64(&x552, &x553, x551, x510, x537);
  uint64_t x554;
  fiat_p434_uint1 x555;
  fiat_p434_addcarryx_u64(&x554, &x555, x553, x512, x539);
  uint64_t x556;
  uint64_t x557;
  fiat_p434_mulx_u64(&x556, &x557, x540, UINT64_C(0x2341f27177344));
  uint64_t x558;
  uint64_t x559;
  fiat_p434_mulx_u64(&x558, &x559, x540, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x560;
  uint64_t x561;
  fiat_p434_mulx_u64(&x560, &x561, x540, UINT64_C(0x7bc65c783158aea3));
  uint64_t x562;
  uint64_t x563;
  fiat_p434_mulx_u64(&x562, &x563, x540, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x564;
  uint64_t x565;
  fiat_p434_mulx_u64(&x564, &x565, x540, UINT64_C(0xffffffffffffffff));
  uint64_t x566;
  uint64_t x567;
  fiat_p434_mulx_u64(&x566, &x567, x540, UINT64_C(0xffffffffffffffff));
  uint64_t x568;
  uint64_t x569;
  fiat_p434_mulx_u64(&x568, &x569, x540, UINT64_C(0xffffffffffffffff));
  uint64_t x570;
  fiat_p434_uint1 x571;
  fiat_p434_addcarryx_u64(&x570, &x571, 0x0, x569, x566);
  uint64_t x572;
  fiat_p434_uint1 x573;
  fiat_p434_addcarryx_u64(&x572, &x573, x571, x567, x564);
  uint64_t x574;
  fiat_p434_uint1 x575;
  fiat_p434_addcarryx_u64(&x574, &x575, x573, x565, x562);
  uint64_t x576;
  fiat_p434_uint1 x577;
  fiat_p434_addcarryx_u64(&x576, &x577, x575, x563, x560);
  uint64_t x578;
  fiat_p434_uint1 x579;
  fiat_p434_addcarryx_u64(&x578, &x579, x577, x561, x558);
  uint64_t x580;
  fiat_p434_uint1 x581;
  fiat_p434_addcarryx_u64(&x580, &x581, x579, x559, x556);
  uint64_t x582 = (x581 + x557);
  uint64_t x583;
  fiat_p434_uint1 x584;
  fiat_p434_addcarryx_u64(&x583, &x584, 0x0, x540, x568);
  uint64_t x585;
  fiat_p434_uint1 x586;
  fiat_p434_addcarryx_u64(&x585, &x586, x584, x542, x570);
  uint64_t x587;
  fiat_p434_uint1 x588;
  fiat_p434_addcarryx_u64(&x587, &x588, x586, x544, x572);
  uint64_t x589;
  fiat_p434_uint1 x590;
  fiat_p434_addcarryx_u64(&x589, &x590, x588, x546, x574);
  uint64_t x591;
  fiat_p434_uint1 x592;
  fiat_p434_addcarryx_u64(&x591, &x592, x590, x548, x576);
  uint64_t x593;
  fiat_p434_uint1 x594;
  fiat_p434_addcarryx_u64(&x593, &x594, x592, x550, x578);
  uint64_t x595;
  fiat_p434_uint1 x596;
  fiat_p434_addcarryx_u64(&x595, &x596, x594, x552, x580);
  uint64_t x597;
  fiat_p434_uint1 x598;
  fiat_p434_addcarryx_u64(&x597, &x598, x596, x554, x582);
  uint64_t x599 = ((uint64_t)x598 + x555);
  uint64_t x600;
  fiat_p434_uint1 x601;
  fiat_p434_subborrowx_u64(&x600, &x601, 0x0, x585, UINT64_C(0xffffffffffffffff));
  uint64_t x602;
  fiat_p434_uint1 x603;
  fiat_p434_subborrowx_u64(&x602, &x603, x601, x587, UINT64_C(0xffffffffffffffff));
  uint64_t x604;
  fiat_p434_uint1 x605;
  fiat_p434_subborrowx_u64(&x604, &x605, x603, x589, UINT64_C(0xffffffffffffffff));
  uint64_t x606;
  fiat_p434_uint1 x607;
  fiat_p434_subborrowx_u64(&x606, &x607, x605, x591, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x608;
  fiat_p434_uint1 x609;
  fiat_p434_subborrowx_u64(&x608, &x609, x607, x593, UINT64_C(0x7bc65c783158aea3));
  uint64_t x610;
  fiat_p434_uint1 x611;
  fiat_p434_subborrowx_u64(&x610, &x611, x609, x595, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x612;
  fiat_p434_uint1 x613;
  fiat_p434_subborrowx_u64(&x612, &x613, x611, x597, UINT64_C(0x2341f27177344));
  uint64_t x614;
  fiat_p434_uint1 x615;
  fiat_p434_subborrowx_u64(&x614, &x615, x613, x599, 0x0);
  uint64_t x616;
  fiat_p434_cmovznz_u64(&x616, x615, x600, x585);
  uint64_t x617;
  fiat_p434_cmovznz_u64(&x617, x615, x602, x587);
  uint64_t x618;
  fiat_p434_cmovznz_u64(&x618, x615, x604, x589);
  uint64_t x619;
  fiat_p434_cmovznz_u64(&x619, x615, x606, x591);
  uint64_t x620;
  fiat_p434_cmovznz_u64(&x620, x615, x608, x593);
  uint64_t x621;
  fiat_p434_cmovznz_u64(&x621, x615, x610, x595);
  uint64_t x622;
  fiat_p434_cmovznz_u64(&x622, x615, x612, x597);
  out1[0] = x616;
  out1[1] = x617;
  out1[2] = x618;
  out1[3] = x619;
  out1[4] = x620;
  out1[5] = x621;
  out1[6] = x622;
}

/*
 * The function fiat_p434_add adds two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
static void fiat_p434_add(uint64_t out1[7], const uint64_t arg1[7], const uint64_t arg2[7]) {
  uint64_t x1;
  fiat_p434_uint1 x2;
  fiat_p434_addcarryx_u64(&x1, &x2, 0x0, (arg1[0]), (arg2[0]));
  uint64_t x3;
  fiat_p434_uint1 x4;
  fiat_p434_addcarryx_u64(&x3, &x4, x2, (arg1[1]), (arg2[1]));
  uint64_t x5;
  fiat_p434_uint1 x6;
  fiat_p434_addcarryx_u64(&x5, &x6, x4, (arg1[2]), (arg2[2]));
  uint64_t x7;
  fiat_p434_uint1 x8;
  fiat_p434_addcarryx_u64(&x7, &x8, x6, (arg1[3]), (arg2[3]));
  uint64_t x9;
  fiat_p434_uint1 x10;
  fiat_p434_addcarryx_u64(&x9, &x10, x8, (arg1[4]), (arg2[4]));
  uint64_t x11;
  fiat_p434_uint1 x12;
  fiat_p434_addcarryx_u64(&x11, &x12, x10, (arg1[5]), (arg2[5]));
  uint64_t x13;
  fiat_p434_uint1 x14;
  fiat_p434_addcarryx_u64(&x13, &x14, x12, (arg1[6]), (arg2[6]));
  uint64_t x15;
  fiat_p434_uint1 x16;
  fiat_p434_subborrowx_u64(&x15, &x16, 0x0, x1, UINT64_C(0xffffffffffffffff));
  uint64_t x17;
  fiat_p434_uint1 x18;
  fiat_p434_subborrowx_u64(&x17, &x18, x16, x3, UINT64_C(0xffffffffffffffff));
  uint64_t x19;
  fiat_p434_uint1 x20;
  fiat_p434_subborrowx_u64(&x19, &x20, x18, x5, UINT64_C(0xffffffffffffffff));
  uint64_t x21;
  fiat_p434_uint1 x22;
  fiat_p434_subborrowx_u64(&x21, &x22, x20, x7, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x23;
  fiat_p434_uint1 x24;
  fiat_p434_subborrowx_u64(&x23, &x24, x22, x9, UINT64_C(0x7bc65c783158aea3));
  uint64_t x25;
  fiat_p434_uint1 x26;
  fiat_p434_subborrowx_u64(&x25, &x26, x24, x11, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x27;
  fiat_p434_uint1 x28;
  fiat_p434_subborrowx_u64(&x27, &x28, x26, x13, UINT64_C(0x2341f27177344));
  uint64_t x29;
  fiat_p434_uint1 x30;
  fiat_p434_subborrowx_u64(&x29, &x30, x28, x14, 0x0);
  uint64_t x31;
  fiat_p434_cmovznz_u64(&x31, x30, x15, x1);
  uint64_t x32;
  fiat_p434_cmovznz_u64(&x32, x30, x17, x3);
  uint64_t x33;
  fiat_p434_cmovznz_u64(&x33, x30, x19, x5);
  uint64_t x34;
  fiat_p434_cmovznz_u64(&x34, x30, x21, x7);
  uint64_t x35;
  fiat_p434_cmovznz_u64(&x35, x30, x23, x9);
  uint64_t x36;
  fiat_p434_cmovznz_u64(&x36, x30, x25, x11);
  uint64_t x37;
  fiat_p434_cmovznz_u64(&x37, x30, x27, x13);
  out1[0] = x31;
  out1[1] = x32;
  out1[2] = x33;
  out1[3] = x34;
  out1[4] = x35;
  out1[5] = x36;
  out1[6] = x37;
}

/*
 * The function fiat_p434_sub subtracts two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
static void fiat_p434_sub(uint64_t out1[7], const uint64_t arg1[7], const uint64_t arg2[7]) {
  uint64_t x1;
  fiat_p434_uint1 x2;
  fiat_p434_subborrowx_u64(&x1, &x2, 0x0, (arg1[0]), (arg2[0]));
  uint64_t x3;
  fiat_p434_uint1 x4;
  fiat_p434_subborrowx_u64(&x3, &x4, x2, (arg1[1]), (arg2[1]));
  uint64_t x5;
  fiat_p434_uint1 x6;
  fiat_p434_subborrowx_u64(&x5, &x6, x4, (arg1[2]), (arg2[2]));
  uint64_t x7;
  fiat_p434_uint1 x8;
  fiat_p434_subborrowx_u64(&x7, &x8, x6, (arg1[3]), (arg2[3]));
  uint64_t x9;
  fiat_p434_uint1 x10;
  fiat_p434_subborrowx_u64(&x9, &x10, x8, (arg1[4]), (arg2[4]));
  uint64_t x11;
  fiat_p434_uint1 x12;
  fiat_p434_subborrowx_u64(&x11, &x12, x10, (arg1[5]), (arg2[5]));
  uint64_t x13;
  fiat_p434_uint1 x14;
  fiat_p434_subborrowx_u64(&x13, &x14, x12, (arg1[6]), (arg2[6]));
  uint64_t x15;
  fiat_p434_cmovznz_u64(&x15, x14, 0x0, UINT64_C(0xffffffffffffffff));
  uint64_t x16;
  fiat_p434_uint1 x17;
  fiat_p434_addcarryx_u64(&x16, &x17, 0x0, x1, (x15 & UINT64_C(0xffffffffffffffff)));
  uint64_t x18;
  fiat_p434_uint1 x19;
  fiat_p434_addcarryx_u64(&x18, &x19, x17, x3, (x15 & UINT64_C(0xffffffffffffffff)));
  uint64_t x20;
  fiat_p434_uint1 x21;
  fiat_p434_addcarryx_u64(&x20, &x21, x19, x5, (x15 & UINT64_C(0xffffffffffffffff)));
  uint64_t x22;
  fiat_p434_uint1 x23;
  fiat_p434_addcarryx_u64(&x22, &x23, x21, x7, (x15 & UINT64_C(0xfdc1767ae2ffffff)));
  uint64_t x24;
  fiat_p434_uint1 x25;
  fiat_p434_addcarryx_u64(&x24, &x25, x23, x9, (x15 & UINT64_C(0x7bc65c783158aea3)));
  uint64_t x26;
  fiat_p434_uint1 x27;
  fiat_p434_addcarryx_u64(&x26, &x27, x25, x11, (x15 & UINT64_C(0x6cfc5fd681c52056)));
  uint64_t x28;
  fiat_p434_uint1 x29;
  fiat_p434_addcarryx_u64(&x28, &x29, x27, x13, (x15 & UINT64_C(0x2341f27177344)));
  out1[0] = x16;
  out1[1] = x18;
  out1[2] = x20;
  out1[3] = x22;
  out1[4] = x24;
  out1[5] = x26;
  out1[6] = x28;
}

/*
 * The function fiat_p434_opp negates a field element in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
static void fiat_p434_opp(uint64_t out1[7], const uint64_t arg1[7]) {
  uint64_t x1;
  fiat_p434_uint1 x2;
  fiat_p434_subborrowx_u64(&x1, &x2, 0x0, 0x0, (arg1[0]));
  uint64_t x3;
  fiat_p434_uint1 x4;
  fiat_p434_subborrowx_u64(&x3, &x4, x2, 0x0, (arg1[1]));
  uint64_t x5;
  fiat_p434_uint1 x6;
  fiat_p434_subborrowx_u64(&x5, &x6, x4, 0x0, (arg1[2]));
  uint64_t x7;
  fiat_p434_uint1 x8;
  fiat_p434_subborrowx_u64(&x7, &x8, x6, 0x0, (arg1[3]));
  uint64_t x9;
  fiat_p434_uint1 x10;
  fiat_p434_subborrowx_u64(&x9, &x10, x8, 0x0, (arg1[4]));
  uint64_t x11;
  fiat_p434_uint1 x12;
  fiat_p434_subborrowx_u64(&x11, &x12, x10, 0x0, (arg1[5]));
  uint64_t x13;
  fiat_p434_uint1 x14;
  fiat_p434_subborrowx_u64(&x13, &x14, x12, 0x0, (arg1[6]));
  uint64_t x15;
  fiat_p434_cmovznz_u64(&x15, x14, 0x0, UINT64_C(0xffffffffffffffff));
  uint64_t x16;
  fiat_p434_uint1 x17;
  fiat_p434_addcarryx_u64(&x16, &x17, 0x0, x1, (x15 & UINT64_C(0xffffffffffffffff)));
  uint64_t x18;
  fiat_p434_uint1 x19;
  fiat_p434_addcarryx_u64(&x18, &x19, x17, x3, (x15 & UINT64_C(0xffffffffffffffff)));
  uint64_t x20;
  fiat_p434_uint1 x21;
  fiat_p434_addcarryx_u64(&x20, &x21, x19, x5, (x15 & UINT64_C(0xffffffffffffffff)));
  uint64_t x22;
  fiat_p434_uint1 x23;
  fiat_p434_addcarryx_u64(&x22, &x23, x21, x7, (x15 & UINT64_C(0xfdc1767ae2ffffff)));
  uint64_t x24;
  fiat_p434_uint1 x25;
  fiat_p434_addcarryx_u64(&x24, &x25, x23, x9, (x15 & UINT64_C(0x7bc65c783158aea3)));
  uint64_t x26;
  fiat_p434_uint1 x27;
  fiat_p434_addcarryx_u64(&x26, &x27, x25, x11, (x15 & UINT64_C(0x6cfc5fd681c52056)));
  uint64_t x28;
  fiat_p434_uint1 x29;
  fiat_p434_addcarryx_u64(&x28, &x29, x27, x13, (x15 & UINT64_C(0x2341f27177344)));
  out1[0] = x16;
  out1[1] = x18;
  out1[2] = x20;
  out1[3] = x22;
  out1[4] = x24;
  out1[5] = x26;
  out1[6] = x28;
}

/*
 * The function fiat_p434_from_montgomery translates a field element out of the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * ((2^64)⁻¹ mod m)^7) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
static void fiat_p434_from_montgomery(uint64_t out1[7], const uint64_t arg1[7]) {
  uint64_t x1 = (arg1[0]);
  uint64_t x2;
  uint64_t x3;
  fiat_p434_mulx_u64(&x2, &x3, x1, UINT64_C(0x2341f27177344));
  uint64_t x4;
  uint64_t x5;
  fiat_p434_mulx_u64(&x4, &x5, x1, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x6;
  uint64_t x7;
  fiat_p434_mulx_u64(&x6, &x7, x1, UINT64_C(0x7bc65c783158aea3));
  uint64_t x8;
  uint64_t x9;
  fiat_p434_mulx_u64(&x8, &x9, x1, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x10;
  uint64_t x11;
  fiat_p434_mulx_u64(&x10, &x11, x1, UINT64_C(0xffffffffffffffff));
  uint64_t x12;
  uint64_t x13;
  fiat_p434_mulx_u64(&x12, &x13, x1, UINT64_C(0xffffffffffffffff));
  uint64_t x14;
  uint64_t x15;
  fiat_p434_mulx_u64(&x14, &x15, x1, UINT64_C(0xffffffffffffffff));
  uint64_t x16;
  fiat_p434_uint1 x17;
  fiat_p434_addcarryx_u64(&x16, &x17, 0x0, x15, x12);
  uint64_t x18;
  fiat_p434_uint1 x19;
  fiat_p434_addcarryx_u64(&x18, &x19, x17, x13, x10);
  uint64_t x20;
  fiat_p434_uint1 x21;
  fiat_p434_addcarryx_u64(&x20, &x21, x19, x11, x8);
  uint64_t x22;
  fiat_p434_uint1 x23;
  fiat_p434_addcarryx_u64(&x22, &x23, x21, x9, x6);
  uint64_t x24;
  fiat_p434_uint1 x25;
  fiat_p434_addcarryx_u64(&x24, &x25, x23, x7, x4);
  uint64_t x26;
  fiat_p434_uint1 x27;
  fiat_p434_addcarryx_u64(&x26, &x27, x25, x5, x2);
  uint64_t x28;
  fiat_p434_uint1 x29;
  fiat_p434_addcarryx_u64(&x28, &x29, 0x0, x1, x14);
  uint64_t x30;
  fiat_p434_uint1 x31;
  fiat_p434_addcarryx_u64(&x30, &x31, x29, 0x0, x16);
  uint64_t x32;
  fiat_p434_uint1 x33;
  fiat_p434_addcarryx_u64(&x32, &x33, x31, 0x0, x18);
  uint64_t x34;
  fiat_p434_uint1 x35;
  fiat_p434_addcarryx_u64(&x34, &x35, x33, 0x0, x20);
  uint64_t x36;
  fiat_p434_uint1 x37;
  fiat_p434_addcarryx_u64(&x36, &x37, x35, 0x0, x22);
  uint64_t x38;
  fiat_p434_uint1 x39;
  fiat_p434_addcarryx_u64(&x38, &x39, x37, 0x0, x24);
  uint64_t x40;
  fiat_p434_uint1 x41;
  fiat_p434_addcarryx_u64(&x40, &x41, x39, 0x0, x26);
  uint64_t x42;
  fiat_p434_uint1 x43;
  fiat_p434_addcarryx_u64(&x42, &x43, 0x0, x30, (arg1[1]));
  uint64_t x44;
  fiat_p434_uint1 x45;
  fiat_p434_addcarryx_u64(&x44, &x45, x43, x32, 0x0);
  uint64_t x46;
  fiat_p434_uint1 x47;
  fiat_p434_addcarryx_u64(&x46, &x47, x45, x34, 0x0);
  uint64_t x48;
  fiat_p434_uint1 x49;
  fiat_p434_addcarryx_u64(&x48, &x49, x47, x36, 0x0);
  uint64_t x50;
  fiat_p434_uint1 x51;
  fiat_p434_addcarryx_u64(&x50, &x51, x49, x38, 0x0);
  uint64_t x52;
  fiat_p434_uint1 x53;
  fiat_p434_addcarryx_u64(&x52, &x53, x51, x40, 0x0);
  uint64_t x54;
  uint64_t x55;
  fiat_p434_mulx_u64(&x54, &x55, x42, UINT64_C(0x2341f27177344));
  uint64_t x56;
  uint64_t x57;
  fiat_p434_mulx_u64(&x56, &x57, x42, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x58;
  uint64_t x59;
  fiat_p434_mulx_u64(&x58, &x59, x42, UINT64_C(0x7bc65c783158aea3));
  uint64_t x60;
  uint64_t x61;
  fiat_p434_mulx_u64(&x60, &x61, x42, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x62;
  uint64_t x63;
  fiat_p434_mulx_u64(&x62, &x63, x42, UINT64_C(0xffffffffffffffff));
  uint64_t x64;
  uint64_t x65;
  fiat_p434_mulx_u64(&x64, &x65, x42, UINT64_C(0xffffffffffffffff));
  uint64_t x66;
  uint64_t x67;
  fiat_p434_mulx_u64(&x66, &x67, x42, UINT64_C(0xffffffffffffffff));
  uint64_t x68;
  fiat_p434_uint1 x69;
  fiat_p434_addcarryx_u64(&x68, &x69, 0x0, x67, x64);
  uint64_t x70;
  fiat_p434_uint1 x71;
  fiat_p434_addcarryx_u64(&x70, &x71, x69, x65, x62);
  uint64_t x72;
  fiat_p434_uint1 x73;
  fiat_p434_addcarryx_u64(&x72, &x73, x71, x63, x60);
  uint64_t x74;
  fiat_p434_uint1 x75;
  fiat_p434_addcarryx_u64(&x74, &x75, x73, x61, x58);
  uint64_t x76;
  fiat_p434_uint1 x77;
  fiat_p434_addcarryx_u64(&x76, &x77, x75, x59, x56);
  uint64_t x78;
  fiat_p434_uint1 x79;
  fiat_p434_addcarryx_u64(&x78, &x79, x77, x57, x54);
  uint64_t x80;
  fiat_p434_uint1 x81;
  fiat_p434_addcarryx_u64(&x80, &x81, 0x0, x42, x66);
  uint64_t x82;
  fiat_p434_uint1 x83;
  fiat_p434_addcarryx_u64(&x82, &x83, x81, x44, x68);
  uint64_t x84;
  fiat_p434_uint1 x85;
  fiat_p434_addcarryx_u64(&x84, &x85, x83, x46, x70);
  uint64_t x86;
  fiat_p434_uint1 x87;
  fiat_p434_addcarryx_u64(&x86, &x87, x85, x48, x72);
  uint64_t x88;
  fiat_p434_uint1 x89;
  fiat_p434_addcarryx_u64(&x88, &x89, x87, x50, x74);
  uint64_t x90;
  fiat_p434_uint1 x91;
  fiat_p434_addcarryx_u64(&x90, &x91, x89, x52, x76);
  uint64_t x92;
  fiat_p434_uint1 x93;
  fiat_p434_addcarryx_u64(&x92, &x93, x91, (x53 + (x41 + (x27 + x3))), x78);
  uint64_t x94;
  fiat_p434_uint1 x95;
  fiat_p434_addcarryx_u64(&x94, &x95, 0x0, x82, (arg1[2]));
  uint64_t x96;
  fiat_p434_uint1 x97;
  fiat_p434_addcarryx_u64(&x96, &x97, x95, x84, 0x0);
  uint64_t x98;
  fiat_p434_uint1 x99;
  fiat_p434_addcarryx_u64(&x98, &x99, x97, x86, 0x0);
  uint64_t x100;
  fiat_p434_uint1 x101;
  fiat_p434_addcarryx_u64(&x100, &x101, x99, x88, 0x0);
  uint64_t x102;
  fiat_p434_uint1 x103;
  fiat_p434_addcarryx_u64(&x102, &x103, x101, x90, 0x0);
  uint64_t x104;
  fiat_p434_uint1 x105;
  fiat_p434_addcarryx_u64(&x104, &x105, x103, x92, 0x0);
  uint64_t x106;
  uint64_t x107;
  fiat_p434_mulx_u64(&x106, &x107, x94, UINT64_C(0x2341f27177344));
  uint64_t x108;
  uint64_t x109;
  fiat_p434_mulx_u64(&x108, &x109, x94, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x110;
  uint64_t x111;
  fiat_p434_mulx_u64(&x110, &x111, x94, UINT64_C(0x7bc65c783158aea3));
  uint64_t x112;
  uint64_t x113;
  fiat_p434_mulx_u64(&x112, &x113, x94, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x114;
  uint64_t x115;
  fiat_p434_mulx_u64(&x114, &x115, x94, UINT64_C(0xffffffffffffffff));
  uint64_t x116;
  uint64_t x117;
  fiat_p434_mulx_u64(&x116, &x117, x94, UINT64_C(0xffffffffffffffff));
  uint64_t x118;
  uint64_t x119;
  fiat_p434_mulx_u64(&x118, &x119, x94, UINT64_C(0xffffffffffffffff));
  uint64_t x120;
  fiat_p434_uint1 x121;
  fiat_p434_addcarryx_u64(&x120, &x121, 0x0, x119, x116);
  uint64_t x122;
  fiat_p434_uint1 x123;
  fiat_p434_addcarryx_u64(&x122, &x123, x121, x117, x114);
  uint64_t x124;
  fiat_p434_uint1 x125;
  fiat_p434_addcarryx_u64(&x124, &x125, x123, x115, x112);
  uint64_t x126;
  fiat_p434_uint1 x127;
  fiat_p434_addcarryx_u64(&x126, &x127, x125, x113, x110);
  uint64_t x128;
  fiat_p434_uint1 x129;
  fiat_p434_addcarryx_u64(&x128, &x129, x127, x111, x108);
  uint64_t x130;
  fiat_p434_uint1 x131;
  fiat_p434_addcarryx_u64(&x130, &x131, x129, x109, x106);
  uint64_t x132;
  fiat_p434_uint1 x133;
  fiat_p434_addcarryx_u64(&x132, &x133, 0x0, x94, x118);
  uint64_t x134;
  fiat_p434_uint1 x135;
  fiat_p434_addcarryx_u64(&x134, &x135, x133, x96, x120);
  uint64_t x136;
  fiat_p434_uint1 x137;
  fiat_p434_addcarryx_u64(&x136, &x137, x135, x98, x122);
  uint64_t x138;
  fiat_p434_uint1 x139;
  fiat_p434_addcarryx_u64(&x138, &x139, x137, x100, x124);
  uint64_t x140;
  fiat_p434_uint1 x141;
  fiat_p434_addcarryx_u64(&x140, &x141, x139, x102, x126);
  uint64_t x142;
  fiat_p434_uint1 x143;
  fiat_p434_addcarryx_u64(&x142, &x143, x141, x104, x128);
  uint64_t x144;
  fiat_p434_uint1 x145;
  fiat_p434_addcarryx_u64(&x144, &x145, x143, (x105 + (x93 + (x79 + x55))), x130);
  uint64_t x146;
  fiat_p434_uint1 x147;
  fiat_p434_addcarryx_u64(&x146, &x147, 0x0, x134, (arg1[3]));
  uint64_t x148;
  fiat_p434_uint1 x149;
  fiat_p434_addcarryx_u64(&x148, &x149, x147, x136, 0x0);
  uint64_t x150;
  fiat_p434_uint1 x151;
  fiat_p434_addcarryx_u64(&x150, &x151, x149, x138, 0x0);
  uint64_t x152;
  fiat_p434_uint1 x153;
  fiat_p434_addcarryx_u64(&x152, &x153, x151, x140, 0x0);
  uint64_t x154;
  fiat_p434_uint1 x155;
  fiat_p434_addcarryx_u64(&x154, &x155, x153, x142, 0x0);
  uint64_t x156;
  fiat_p434_uint1 x157;
  fiat_p434_addcarryx_u64(&x156, &x157, x155, x144, 0x0);
  uint64_t x158;
  uint64_t x159;
  fiat_p434_mulx_u64(&x158, &x159, x146, UINT64_C(0x2341f27177344));
  uint64_t x160;
  uint64_t x161;
  fiat_p434_mulx_u64(&x160, &x161, x146, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x162;
  uint64_t x163;
  fiat_p434_mulx_u64(&x162, &x163, x146, UINT64_C(0x7bc65c783158aea3));
  uint64_t x164;
  uint64_t x165;
  fiat_p434_mulx_u64(&x164, &x165, x146, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x166;
  uint64_t x167;
  fiat_p434_mulx_u64(&x166, &x167, x146, UINT64_C(0xffffffffffffffff));
  uint64_t x168;
  uint64_t x169;
  fiat_p434_mulx_u64(&x168, &x169, x146, UINT64_C(0xffffffffffffffff));
  uint64_t x170;
  uint64_t x171;
  fiat_p434_mulx_u64(&x170, &x171, x146, UINT64_C(0xffffffffffffffff));
  uint64_t x172;
  fiat_p434_uint1 x173;
  fiat_p434_addcarryx_u64(&x172, &x173, 0x0, x171, x168);
  uint64_t x174;
  fiat_p434_uint1 x175;
  fiat_p434_addcarryx_u64(&x174, &x175, x173, x169, x166);
  uint64_t x176;
  fiat_p434_uint1 x177;
  fiat_p434_addcarryx_u64(&x176, &x177, x175, x167, x164);
  uint64_t x178;
  fiat_p434_uint1 x179;
  fiat_p434_addcarryx_u64(&x178, &x179, x177, x165, x162);
  uint64_t x180;
  fiat_p434_uint1 x181;
  fiat_p434_addcarryx_u64(&x180, &x181, x179, x163, x160);
  uint64_t x182;
  fiat_p434_uint1 x183;
  fiat_p434_addcarryx_u64(&x182, &x183, x181, x161, x158);
  uint64_t x184;
  fiat_p434_uint1 x185;
  fiat_p434_addcarryx_u64(&x184, &x185, 0x0, x146, x170);
  uint64_t x186;
  fiat_p434_uint1 x187;
  fiat_p434_addcarryx_u64(&x186, &x187, x185, x148, x172);
  uint64_t x188;
  fiat_p434_uint1 x189;
  fiat_p434_addcarryx_u64(&x188, &x189, x187, x150, x174);
  uint64_t x190;
  fiat_p434_uint1 x191;
  fiat_p434_addcarryx_u64(&x190, &x191, x189, x152, x176);
  uint64_t x192;
  fiat_p434_uint1 x193;
  fiat_p434_addcarryx_u64(&x192, &x193, x191, x154, x178);
  uint64_t x194;
  fiat_p434_uint1 x195;
  fiat_p434_addcarryx_u64(&x194, &x195, x193, x156, x180);
  uint64_t x196;
  fiat_p434_uint1 x197;
  fiat_p434_addcarryx_u64(&x196, &x197, x195, (x157 + (x145 + (x131 + x107))), x182);
  uint64_t x198;
  fiat_p434_uint1 x199;
  fiat_p434_addcarryx_u64(&x198, &x199, 0x0, x186, (arg1[4]));
  uint64_t x200;
  fiat_p434_uint1 x201;
  fiat_p434_addcarryx_u64(&x200, &x201, x199, x188, 0x0);
  uint64_t x202;
  fiat_p434_uint1 x203;
  fiat_p434_addcarryx_u64(&x202, &x203, x201, x190, 0x0);
  uint64_t x204;
  fiat_p434_uint1 x205;
  fiat_p434_addcarryx_u64(&x204, &x205, x203, x192, 0x0);
  uint64_t x206;
  fiat_p434_uint1 x207;
  fiat_p434_addcarryx_u64(&x206, &x207, x205, x194, 0x0);
  uint64_t x208;
  fiat_p434_uint1 x209;
  fiat_p434_addcarryx_u64(&x208, &x209, x207, x196, 0x0);
  uint64_t x210;
  uint64_t x211;
  fiat_p434_mulx_u64(&x210, &x211, x198, UINT64_C(0x2341f27177344));
  uint64_t x212;
  uint64_t x213;
  fiat_p434_mulx_u64(&x212, &x213, x198, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x214;
  uint64_t x215;
  fiat_p434_mulx_u64(&x214, &x215, x198, UINT64_C(0x7bc65c783158aea3));
  uint64_t x216;
  uint64_t x217;
  fiat_p434_mulx_u64(&x216, &x217, x198, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x218;
  uint64_t x219;
  fiat_p434_mulx_u64(&x218, &x219, x198, UINT64_C(0xffffffffffffffff));
  uint64_t x220;
  uint64_t x221;
  fiat_p434_mulx_u64(&x220, &x221, x198, UINT64_C(0xffffffffffffffff));
  uint64_t x222;
  uint64_t x223;
  fiat_p434_mulx_u64(&x222, &x223, x198, UINT64_C(0xffffffffffffffff));
  uint64_t x224;
  fiat_p434_uint1 x225;
  fiat_p434_addcarryx_u64(&x224, &x225, 0x0, x223, x220);
  uint64_t x226;
  fiat_p434_uint1 x227;
  fiat_p434_addcarryx_u64(&x226, &x227, x225, x221, x218);
  uint64_t x228;
  fiat_p434_uint1 x229;
  fiat_p434_addcarryx_u64(&x228, &x229, x227, x219, x216);
  uint64_t x230;
  fiat_p434_uint1 x231;
  fiat_p434_addcarryx_u64(&x230, &x231, x229, x217, x214);
  uint64_t x232;
  fiat_p434_uint1 x233;
  fiat_p434_addcarryx_u64(&x232, &x233, x231, x215, x212);
  uint64_t x234;
  fiat_p434_uint1 x235;
  fiat_p434_addcarryx_u64(&x234, &x235, x233, x213, x210);
  uint64_t x236;
  fiat_p434_uint1 x237;
  fiat_p434_addcarryx_u64(&x236, &x237, 0x0, x198, x222);
  uint64_t x238;
  fiat_p434_uint1 x239;
  fiat_p434_addcarryx_u64(&x238, &x239, x237, x200, x224);
  uint64_t x240;
  fiat_p434_uint1 x241;
  fiat_p434_addcarryx_u64(&x240, &x241, x239, x202, x226);
  uint64_t x242;
  fiat_p434_uint1 x243;
  fiat_p434_addcarryx_u64(&x242, &x243, x241, x204, x228);
  uint64_t x244;
  fiat_p434_uint1 x245;
  fiat_p434_addcarryx_u64(&x244, &x245, x243, x206, x230);
  uint64_t x246;
  fiat_p434_uint1 x247;
  fiat_p434_addcarryx_u64(&x246, &x247, x245, x208, x232);
  uint64_t x248;
  fiat_p434_uint1 x249;
  fiat_p434_addcarryx_u64(&x248, &x249, x247, (x209 + (x197 + (x183 + x159))), x234);
  uint64_t x250;
  fiat_p434_uint1 x251;
  fiat_p434_addcarryx_u64(&x250, &x251, 0x0, x238, (arg1[5]));
  uint64_t x252;
  fiat_p434_uint1 x253;
  fiat_p434_addcarryx_u64(&x252, &x253, x251, x240, 0x0);
  uint64_t x254;
  fiat_p434_uint1 x255;
  fiat_p434_addcarryx_u64(&x254, &x255, x253, x242, 0x0);
  uint64_t x256;
  fiat_p434_uint1 x257;
  fiat_p434_addcarryx_u64(&x256, &x257, x255, x244, 0x0);
  uint64_t x258;
  fiat_p434_uint1 x259;
  fiat_p434_addcarryx_u64(&x258, &x259, x257, x246, 0x0);
  uint64_t x260;
  fiat_p434_uint1 x261;
  fiat_p434_addcarryx_u64(&x260, &x261, x259, x248, 0x0);
  uint64_t x262;
  uint64_t x263;
  fiat_p434_mulx_u64(&x262, &x263, x250, UINT64_C(0x2341f27177344));
  uint64_t x264;
  uint64_t x265;
  fiat_p434_mulx_u64(&x264, &x265, x250, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x266;
  uint64_t x267;
  fiat_p434_mulx_u64(&x266, &x267, x250, UINT64_C(0x7bc65c783158aea3));
  uint64_t x268;
  uint64_t x269;
  fiat_p434_mulx_u64(&x268, &x269, x250, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x270;
  uint64_t x271;
  fiat_p434_mulx_u64(&x270, &x271, x250, UINT64_C(0xffffffffffffffff));
  uint64_t x272;
  uint64_t x273;
  fiat_p434_mulx_u64(&x272, &x273, x250, UINT64_C(0xffffffffffffffff));
  uint64_t x274;
  uint64_t x275;
  fiat_p434_mulx_u64(&x274, &x275, x250, UINT64_C(0xffffffffffffffff));
  uint64_t x276;
  fiat_p434_uint1 x277;
  fiat_p434_addcarryx_u64(&x276, &x277, 0x0, x275, x272);
  uint64_t x278;
  fiat_p434_uint1 x279;
  fiat_p434_addcarryx_u64(&x278, &x279, x277, x273, x270);
  uint64_t x280;
  fiat_p434_uint1 x281;
  fiat_p434_addcarryx_u64(&x280, &x281, x279, x271, x268);
  uint64_t x282;
  fiat_p434_uint1 x283;
  fiat_p434_addcarryx_u64(&x282, &x283, x281, x269, x266);
  uint64_t x284;
  fiat_p434_uint1 x285;
  fiat_p434_addcarryx_u64(&x284, &x285, x283, x267, x264);
  uint64_t x286;
  fiat_p434_uint1 x287;
  fiat_p434_addcarryx_u64(&x286, &x287, x285, x265, x262);
  uint64_t x288;
  fiat_p434_uint1 x289;
  fiat_p434_addcarryx_u64(&x288, &x289, 0x0, x250, x274);
  uint64_t x290;
  fiat_p434_uint1 x291;
  fiat_p434_addcarryx_u64(&x290, &x291, x289, x252, x276);
  uint64_t x292;
  fiat_p434_uint1 x293;
  fiat_p434_addcarryx_u64(&x292, &x293, x291, x254, x278);
  uint64_t x294;
  fiat_p434_uint1 x295;
  fiat_p434_addcarryx_u64(&x294, &x295, x293, x256, x280);
  uint64_t x296;
  fiat_p434_uint1 x297;
  fiat_p434_addcarryx_u64(&x296, &x297, x295, x258, x282);
  uint64_t x298;
  fiat_p434_uint1 x299;
  fiat_p434_addcarryx_u64(&x298, &x299, x297, x260, x284);
  uint64_t x300;
  fiat_p434_uint1 x301;
  fiat_p434_addcarryx_u64(&x300, &x301, x299, (x261 + (x249 + (x235 + x211))), x286);
  uint64_t x302;
  fiat_p434_uint1 x303;
  fiat_p434_addcarryx_u64(&x302, &x303, 0x0, x290, (arg1[6]));
  uint64_t x304;
  fiat_p434_uint1 x305;
  fiat_p434_addcarryx_u64(&x304, &x305, x303, x292, 0x0);
  uint64_t x306;
  fiat_p434_uint1 x307;
  fiat_p434_addcarryx_u64(&x306, &x307, x305, x294, 0x0);
  uint64_t x308;
  fiat_p434_uint1 x309;
  fiat_p434_addcarryx_u64(&x308, &x309, x307, x296, 0x0);
  uint64_t x310;
  fiat_p434_uint1 x311;
  fiat_p434_addcarryx_u64(&x310, &x311, x309, x298, 0x0);
  uint64_t x312;
  fiat_p434_uint1 x313;
  fiat_p434_addcarryx_u64(&x312, &x313, x311, x300, 0x0);
  uint64_t x314;
  uint64_t x315;
  fiat_p434_mulx_u64(&x314, &x315, x302, UINT64_C(0x2341f27177344));
  uint64_t x316;
  uint64_t x317;
  fiat_p434_mulx_u64(&x316, &x317, x302, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x318;
  uint64_t x319;
  fiat_p434_mulx_u64(&x318, &x319, x302, UINT64_C(0x7bc65c783158aea3));
  uint64_t x320;
  uint64_t x321;
  fiat_p434_mulx_u64(&x320, &x321, x302, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x322;
  uint64_t x323;
  fiat_p434_mulx_u64(&x322, &x323, x302, UINT64_C(0xffffffffffffffff));
  uint64_t x324;
  uint64_t x325;
  fiat_p434_mulx_u64(&x324, &x325, x302, UINT64_C(0xffffffffffffffff));
  uint64_t x326;
  uint64_t x327;
  fiat_p434_mulx_u64(&x326, &x327, x302, UINT64_C(0xffffffffffffffff));
  uint64_t x328;
  fiat_p434_uint1 x329;
  fiat_p434_addcarryx_u64(&x328, &x329, 0x0, x327, x324);
  uint64_t x330;
  fiat_p434_uint1 x331;
  fiat_p434_addcarryx_u64(&x330, &x331, x329, x325, x322);
  uint64_t x332;
  fiat_p434_uint1 x333;
  fiat_p434_addcarryx_u64(&x332, &x333, x331, x323, x320);
  uint64_t x334;
  fiat_p434_uint1 x335;
  fiat_p434_addcarryx_u64(&x334, &x335, x333, x321, x318);
  uint64_t x336;
  fiat_p434_uint1 x337;
  fiat_p434_addcarryx_u64(&x336, &x337, x335, x319, x316);
  uint64_t x338;
  fiat_p434_uint1 x339;
  fiat_p434_addcarryx_u64(&x338, &x339, x337, x317, x314);
  uint64_t x340;
  fiat_p434_uint1 x341;
  fiat_p434_addcarryx_u64(&x340, &x341, 0x0, x302, x326);
  uint64_t x342;
  fiat_p434_uint1 x343;
  fiat_p434_addcarryx_u64(&x342, &x343, x341, x304, x328);
  uint64_t x344;
  fiat_p434_uint1 x345;
  fiat_p434_addcarryx_u64(&x344, &x345, x343, x306, x330);
  uint64_t x346;
  fiat_p434_uint1 x347;
  fiat_p434_addcarryx_u64(&x346, &x347, x345, x308, x332);
  uint64_t x348;
  fiat_p434_uint1 x349;
  fiat_p434_addcarryx_u64(&x348, &x349, x347, x310, x334);
  uint64_t x350;
  fiat_p434_uint1 x351;
  fiat_p434_addcarryx_u64(&x350, &x351, x349, x312, x336);
  uint64_t x352;
  fiat_p434_uint1 x353;
  fiat_p434_addcarryx_u64(&x352, &x353, x351, (x313 + (x301 + (x287 + x263))), x338);
  uint64_t x354 = (x353 + (x339 + x315));
  uint64_t x355;
  fiat_p434_uint1 x356;
  fiat_p434_subborrowx_u64(&x355, &x356, 0x0, x342, UINT64_C(0xffffffffffffffff));
  uint64_t x357;
  fiat_p434_uint1 x358;
  fiat_p434_subborrowx_u64(&x357, &x358, x356, x344, UINT64_C(0xffffffffffffffff));
  uint64_t x359;
  fiat_p434_uint1 x360;
  fiat_p434_subborrowx_u64(&x359, &x360, x358, x346, UINT64_C(0xffffffffffffffff));
  uint64_t x361;
  fiat_p434_uint1 x362;
  fiat_p434_subborrowx_u64(&x361, &x362, x360, x348, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x363;
  fiat_p434_uint1 x364;
  fiat_p434_subborrowx_u64(&x363, &x364, x362, x350, UINT64_C(0x7bc65c783158aea3));
  uint64_t x365;
  fiat_p434_uint1 x366;
  fiat_p434_subborrowx_u64(&x365, &x366, x364, x352, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x367;
  fiat_p434_uint1 x368;
  fiat_p434_subborrowx_u64(&x367, &x368, x366, x354, UINT64_C(0x2341f27177344));
  uint64_t x369;
  fiat_p434_uint1 x370;
  fiat_p434_subborrowx_u64(&x369, &x370, x368, 0x0, 0x0);
  uint64_t x371;
  fiat_p434_cmovznz_u64(&x371, x370, x355, x342);
  uint64_t x372;
  fiat_p434_cmovznz_u64(&x372, x370, x357, x344);
  uint64_t x373;
  fiat_p434_cmovznz_u64(&x373, x370, x359, x346);
  uint64_t x374;
  fiat_p434_cmovznz_u64(&x374, x370, x361, x348);
  uint64_t x375;
  fiat_p434_cmovznz_u64(&x375, x370, x363, x350);
  uint64_t x376;
  fiat_p434_cmovznz_u64(&x376, x370, x365, x352);
  uint64_t x377;
  fiat_p434_cmovznz_u64(&x377, x370, x367, x354);
  out1[0] = x371;
  out1[1] = x372;
  out1[2] = x373;
  out1[3] = x374;
  out1[4] = x375;
  out1[5] = x376;
  out1[6] = x377;
}

/*
 * The function fiat_p434_to_montgomery translates a field element into the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
static void fiat_p434_to_montgomery(uint64_t out1[7], const uint64_t arg1[7]) {
  uint64_t x1 = (arg1[1]);
  uint64_t x2 = (arg1[2]);
  uint64_t x3 = (arg1[3]);
  uint64_t x4 = (arg1[4]);
  uint64_t x5 = (arg1[5]);
  uint64_t x6 = (arg1[6]);
  uint64_t x7 = (arg1[0]);
  uint64_t x8;
  uint64_t x9;
  fiat_p434_mulx_u64(&x8, &x9, x7, UINT64_C(0x25a89bcdd12a));
  uint64_t x10;
  uint64_t x11;
  fiat_p434_mulx_u64(&x10, &x11, x7, UINT64_C(0x69e16a61c7686d9a));
  uint64_t x12;
  uint64_t x13;
  fiat_p434_mulx_u64(&x12, &x13, x7, UINT64_C(0xabcd92bf2dde347e));
  uint64_t x14;
  uint64_t x15;
  fiat_p434_mulx_u64(&x14, &x15, x7, UINT64_C(0x175cc6af8d6c7c0b));
  uint64_t x16;
  uint64_t x17;
  fiat_p434_mulx_u64(&x16, &x17, x7, UINT64_C(0xab27973f8311688d));
  uint64_t x18;
  uint64_t x19;
  fiat_p434_mulx_u64(&x18, &x19, x7, UINT64_C(0xacec7367768798c2));
  uint64_t x20;
  uint64_t x21;
  fiat_p434_mulx_u64(&x20, &x21, x7, UINT64_C(0x28e55b65dcd69b30));
  uint64_t x22;
  fiat_p434_uint1 x23;
  fiat_p434_addcarryx_u64(&x22, &x23, 0x0, x21, x18);
  uint64_t x24;
  fiat_p434_uint1 x25;
  fiat_p434_addcarryx_u64(&x24, &x25, x23, x19, x16);
  uint64_t x26;
  fiat_p434_uint1 x27;
  fiat_p434_addcarryx_u64(&x26, &x27, x25, x17, x14);
  uint64_t x28;
  fiat_p434_uint1 x29;
  fiat_p434_addcarryx_u64(&x28, &x29, x27, x15, x12);
  uint64_t x30;
  fiat_p434_uint1 x31;
  fiat_p434_addcarryx_u64(&x30, &x31, x29, x13, x10);
  uint64_t x32;
  fiat_p434_uint1 x33;
  fiat_p434_addcarryx_u64(&x32, &x33, x31, x11, x8);
  uint64_t x34;
  uint64_t x35;
  fiat_p434_mulx_u64(&x34, &x35, x20, UINT64_C(0x2341f27177344));
  uint64_t x36;
  uint64_t x37;
  fiat_p434_mulx_u64(&x36, &x37, x20, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x38;
  uint64_t x39;
  fiat_p434_mulx_u64(&x38, &x39, x20, UINT64_C(0x7bc65c783158aea3));
  uint64_t x40;
  uint64_t x41;
  fiat_p434_mulx_u64(&x40, &x41, x20, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x42;
  uint64_t x43;
  fiat_p434_mulx_u64(&x42, &x43, x20, UINT64_C(0xffffffffffffffff));
  uint64_t x44;
  uint64_t x45;
  fiat_p434_mulx_u64(&x44, &x45, x20, UINT64_C(0xffffffffffffffff));
  uint64_t x46;
  uint64_t x47;
  fiat_p434_mulx_u64(&x46, &x47, x20, UINT64_C(0xffffffffffffffff));
  uint64_t x48;
  fiat_p434_uint1 x49;
  fiat_p434_addcarryx_u64(&x48, &x49, 0x0, x47, x44);
  uint64_t x50;
  fiat_p434_uint1 x51;
  fiat_p434_addcarryx_u64(&x50, &x51, x49, x45, x42);
  uint64_t x52;
  fiat_p434_uint1 x53;
  fiat_p434_addcarryx_u64(&x52, &x53, x51, x43, x40);
  uint64_t x54;
  fiat_p434_uint1 x55;
  fiat_p434_addcarryx_u64(&x54, &x55, x53, x41, x38);
  uint64_t x56;
  fiat_p434_uint1 x57;
  fiat_p434_addcarryx_u64(&x56, &x57, x55, x39, x36);
  uint64_t x58;
  fiat_p434_uint1 x59;
  fiat_p434_addcarryx_u64(&x58, &x59, x57, x37, x34);
  uint64_t x60;
  fiat_p434_uint1 x61;
  fiat_p434_addcarryx_u64(&x60, &x61, 0x0, x20, x46);
  uint64_t x62;
  fiat_p434_uint1 x63;
  fiat_p434_addcarryx_u64(&x62, &x63, x61, x22, x48);
  uint64_t x64;
  fiat_p434_uint1 x65;
  fiat_p434_addcarryx_u64(&x64, &x65, x63, x24, x50);
  uint64_t x66;
  fiat_p434_uint1 x67;
  fiat_p434_addcarryx_u64(&x66, &x67, x65, x26, x52);
  uint64_t x68;
  fiat_p434_uint1 x69;
  fiat_p434_addcarryx_u64(&x68, &x69, x67, x28, x54);
  uint64_t x70;
  fiat_p434_uint1 x71;
  fiat_p434_addcarryx_u64(&x70, &x71, x69, x30, x56);
  uint64_t x72;
  fiat_p434_uint1 x73;
  fiat_p434_addcarryx_u64(&x72, &x73, x71, x32, x58);
  uint64_t x74;
  uint64_t x75;
  fiat_p434_mulx_u64(&x74, &x75, x1, UINT64_C(0x25a89bcdd12a));
  uint64_t x76;
  uint64_t x77;
  fiat_p434_mulx_u64(&x76, &x77, x1, UINT64_C(0x69e16a61c7686d9a));
  uint64_t x78;
  uint64_t x79;
  fiat_p434_mulx_u64(&x78, &x79, x1, UINT64_C(0xabcd92bf2dde347e));
  uint64_t x80;
  uint64_t x81;
  fiat_p434_mulx_u64(&x80, &x81, x1, UINT64_C(0x175cc6af8d6c7c0b));
  uint64_t x82;
  uint64_t x83;
  fiat_p434_mulx_u64(&x82, &x83, x1, UINT64_C(0xab27973f8311688d));
  uint64_t x84;
  uint64_t x85;
  fiat_p434_mulx_u64(&x84, &x85, x1, UINT64_C(0xacec7367768798c2));
  uint64_t x86;
  uint64_t x87;
  fiat_p434_mulx_u64(&x86, &x87, x1, UINT64_C(0x28e55b65dcd69b30));
  uint64_t x88;
  fiat_p434_uint1 x89;
  fiat_p434_addcarryx_u64(&x88, &x89, 0x0, x87, x84);
  uint64_t x90;
  fiat_p434_uint1 x91;
  fiat_p434_addcarryx_u64(&x90, &x91, x89, x85, x82);
  uint64_t x92;
  fiat_p434_uint1 x93;
  fiat_p434_addcarryx_u64(&x92, &x93, x91, x83, x80);
  uint64_t x94;
  fiat_p434_uint1 x95;
  fiat_p434_addcarryx_u64(&x94, &x95, x93, x81, x78);
  uint64_t x96;
  fiat_p434_uint1 x97;
  fiat_p434_addcarryx_u64(&x96, &x97, x95, x79, x76);
  uint64_t x98;
  fiat_p434_uint1 x99;
  fiat_p434_addcarryx_u64(&x98, &x99, x97, x77, x74);
  uint64_t x100;
  fiat_p434_uint1 x101;
  fiat_p434_addcarryx_u64(&x100, &x101, 0x0, x62, x86);
  uint64_t x102;
  fiat_p434_uint1 x103;
  fiat_p434_addcarryx_u64(&x102, &x103, x101, x64, x88);
  uint64_t x104;
  fiat_p434_uint1 x105;
  fiat_p434_addcarryx_u64(&x104, &x105, x103, x66, x90);
  uint64_t x106;
  fiat_p434_uint1 x107;
  fiat_p434_addcarryx_u64(&x106, &x107, x105, x68, x92);
  uint64_t x108;
  fiat_p434_uint1 x109;
  fiat_p434_addcarryx_u64(&x108, &x109, x107, x70, x94);
  uint64_t x110;
  fiat_p434_uint1 x111;
  fiat_p434_addcarryx_u64(&x110, &x111, x109, x72, x96);
  uint64_t x112;
  fiat_p434_uint1 x113;
  fiat_p434_addcarryx_u64(&x112, &x113, x111, ((x73 + (x33 + x9)) + (x59 + x35)), x98);
  uint64_t x114;
  uint64_t x115;
  fiat_p434_mulx_u64(&x114, &x115, x100, UINT64_C(0x2341f27177344));
  uint64_t x116;
  uint64_t x117;
  fiat_p434_mulx_u64(&x116, &x117, x100, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x118;
  uint64_t x119;
  fiat_p434_mulx_u64(&x118, &x119, x100, UINT64_C(0x7bc65c783158aea3));
  uint64_t x120;
  uint64_t x121;
  fiat_p434_mulx_u64(&x120, &x121, x100, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x122;
  uint64_t x123;
  fiat_p434_mulx_u64(&x122, &x123, x100, UINT64_C(0xffffffffffffffff));
  uint64_t x124;
  uint64_t x125;
  fiat_p434_mulx_u64(&x124, &x125, x100, UINT64_C(0xffffffffffffffff));
  uint64_t x126;
  uint64_t x127;
  fiat_p434_mulx_u64(&x126, &x127, x100, UINT64_C(0xffffffffffffffff));
  uint64_t x128;
  fiat_p434_uint1 x129;
  fiat_p434_addcarryx_u64(&x128, &x129, 0x0, x127, x124);
  uint64_t x130;
  fiat_p434_uint1 x131;
  fiat_p434_addcarryx_u64(&x130, &x131, x129, x125, x122);
  uint64_t x132;
  fiat_p434_uint1 x133;
  fiat_p434_addcarryx_u64(&x132, &x133, x131, x123, x120);
  uint64_t x134;
  fiat_p434_uint1 x135;
  fiat_p434_addcarryx_u64(&x134, &x135, x133, x121, x118);
  uint64_t x136;
  fiat_p434_uint1 x137;
  fiat_p434_addcarryx_u64(&x136, &x137, x135, x119, x116);
  uint64_t x138;
  fiat_p434_uint1 x139;
  fiat_p434_addcarryx_u64(&x138, &x139, x137, x117, x114);
  uint64_t x140;
  fiat_p434_uint1 x141;
  fiat_p434_addcarryx_u64(&x140, &x141, 0x0, x100, x126);
  uint64_t x142;
  fiat_p434_uint1 x143;
  fiat_p434_addcarryx_u64(&x142, &x143, x141, x102, x128);
  uint64_t x144;
  fiat_p434_uint1 x145;
  fiat_p434_addcarryx_u64(&x144, &x145, x143, x104, x130);
  uint64_t x146;
  fiat_p434_uint1 x147;
  fiat_p434_addcarryx_u64(&x146, &x147, x145, x106, x132);
  uint64_t x148;
  fiat_p434_uint1 x149;
  fiat_p434_addcarryx_u64(&x148, &x149, x147, x108, x134);
  uint64_t x150;
  fiat_p434_uint1 x151;
  fiat_p434_addcarryx_u64(&x150, &x151, x149, x110, x136);
  uint64_t x152;
  fiat_p434_uint1 x153;
  fiat_p434_addcarryx_u64(&x152, &x153, x151, x112, x138);
  uint64_t x154;
  uint64_t x155;
  fiat_p434_mulx_u64(&x154, &x155, x2, UINT64_C(0x25a89bcdd12a));
  uint64_t x156;
  uint64_t x157;
  fiat_p434_mulx_u64(&x156, &x157, x2, UINT64_C(0x69e16a61c7686d9a));
  uint64_t x158;
  uint64_t x159;
  fiat_p434_mulx_u64(&x158, &x159, x2, UINT64_C(0xabcd92bf2dde347e));
  uint64_t x160;
  uint64_t x161;
  fiat_p434_mulx_u64(&x160, &x161, x2, UINT64_C(0x175cc6af8d6c7c0b));
  uint64_t x162;
  uint64_t x163;
  fiat_p434_mulx_u64(&x162, &x163, x2, UINT64_C(0xab27973f8311688d));
  uint64_t x164;
  uint64_t x165;
  fiat_p434_mulx_u64(&x164, &x165, x2, UINT64_C(0xacec7367768798c2));
  uint64_t x166;
  uint64_t x167;
  fiat_p434_mulx_u64(&x166, &x167, x2, UINT64_C(0x28e55b65dcd69b30));
  uint64_t x168;
  fiat_p434_uint1 x169;
  fiat_p434_addcarryx_u64(&x168, &x169, 0x0, x167, x164);
  uint64_t x170;
  fiat_p434_uint1 x171;
  fiat_p434_addcarryx_u64(&x170, &x171, x169, x165, x162);
  uint64_t x172;
  fiat_p434_uint1 x173;
  fiat_p434_addcarryx_u64(&x172, &x173, x171, x163, x160);
  uint64_t x174;
  fiat_p434_uint1 x175;
  fiat_p434_addcarryx_u64(&x174, &x175, x173, x161, x158);
  uint64_t x176;
  fiat_p434_uint1 x177;
  fiat_p434_addcarryx_u64(&x176, &x177, x175, x159, x156);
  uint64_t x178;
  fiat_p434_uint1 x179;
  fiat_p434_addcarryx_u64(&x178, &x179, x177, x157, x154);
  uint64_t x180;
  fiat_p434_uint1 x181;
  fiat_p434_addcarryx_u64(&x180, &x181, 0x0, x142, x166);
  uint64_t x182;
  fiat_p434_uint1 x183;
  fiat_p434_addcarryx_u64(&x182, &x183, x181, x144, x168);
  uint64_t x184;
  fiat_p434_uint1 x185;
  fiat_p434_addcarryx_u64(&x184, &x185, x183, x146, x170);
  uint64_t x186;
  fiat_p434_uint1 x187;
  fiat_p434_addcarryx_u64(&x186, &x187, x185, x148, x172);
  uint64_t x188;
  fiat_p434_uint1 x189;
  fiat_p434_addcarryx_u64(&x188, &x189, x187, x150, x174);
  uint64_t x190;
  fiat_p434_uint1 x191;
  fiat_p434_addcarryx_u64(&x190, &x191, x189, x152, x176);
  uint64_t x192;
  fiat_p434_uint1 x193;
  fiat_p434_addcarryx_u64(&x192, &x193, x191, ((x153 + (x113 + (x99 + x75))) + (x139 + x115)), x178);
  uint64_t x194;
  uint64_t x195;
  fiat_p434_mulx_u64(&x194, &x195, x180, UINT64_C(0x2341f27177344));
  uint64_t x196;
  uint64_t x197;
  fiat_p434_mulx_u64(&x196, &x197, x180, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x198;
  uint64_t x199;
  fiat_p434_mulx_u64(&x198, &x199, x180, UINT64_C(0x7bc65c783158aea3));
  uint64_t x200;
  uint64_t x201;
  fiat_p434_mulx_u64(&x200, &x201, x180, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x202;
  uint64_t x203;
  fiat_p434_mulx_u64(&x202, &x203, x180, UINT64_C(0xffffffffffffffff));
  uint64_t x204;
  uint64_t x205;
  fiat_p434_mulx_u64(&x204, &x205, x180, UINT64_C(0xffffffffffffffff));
  uint64_t x206;
  uint64_t x207;
  fiat_p434_mulx_u64(&x206, &x207, x180, UINT64_C(0xffffffffffffffff));
  uint64_t x208;
  fiat_p434_uint1 x209;
  fiat_p434_addcarryx_u64(&x208, &x209, 0x0, x207, x204);
  uint64_t x210;
  fiat_p434_uint1 x211;
  fiat_p434_addcarryx_u64(&x210, &x211, x209, x205, x202);
  uint64_t x212;
  fiat_p434_uint1 x213;
  fiat_p434_addcarryx_u64(&x212, &x213, x211, x203, x200);
  uint64_t x214;
  fiat_p434_uint1 x215;
  fiat_p434_addcarryx_u64(&x214, &x215, x213, x201, x198);
  uint64_t x216;
  fiat_p434_uint1 x217;
  fiat_p434_addcarryx_u64(&x216, &x217, x215, x199, x196);
  uint64_t x218;
  fiat_p434_uint1 x219;
  fiat_p434_addcarryx_u64(&x218, &x219, x217, x197, x194);
  uint64_t x220;
  fiat_p434_uint1 x221;
  fiat_p434_addcarryx_u64(&x220, &x221, 0x0, x180, x206);
  uint64_t x222;
  fiat_p434_uint1 x223;
  fiat_p434_addcarryx_u64(&x222, &x223, x221, x182, x208);
  uint64_t x224;
  fiat_p434_uint1 x225;
  fiat_p434_addcarryx_u64(&x224, &x225, x223, x184, x210);
  uint64_t x226;
  fiat_p434_uint1 x227;
  fiat_p434_addcarryx_u64(&x226, &x227, x225, x186, x212);
  uint64_t x228;
  fiat_p434_uint1 x229;
  fiat_p434_addcarryx_u64(&x228, &x229, x227, x188, x214);
  uint64_t x230;
  fiat_p434_uint1 x231;
  fiat_p434_addcarryx_u64(&x230, &x231, x229, x190, x216);
  uint64_t x232;
  fiat_p434_uint1 x233;
  fiat_p434_addcarryx_u64(&x232, &x233, x231, x192, x218);
  uint64_t x234;
  uint64_t x235;
  fiat_p434_mulx_u64(&x234, &x235, x3, UINT64_C(0x25a89bcdd12a));
  uint64_t x236;
  uint64_t x237;
  fiat_p434_mulx_u64(&x236, &x237, x3, UINT64_C(0x69e16a61c7686d9a));
  uint64_t x238;
  uint64_t x239;
  fiat_p434_mulx_u64(&x238, &x239, x3, UINT64_C(0xabcd92bf2dde347e));
  uint64_t x240;
  uint64_t x241;
  fiat_p434_mulx_u64(&x240, &x241, x3, UINT64_C(0x175cc6af8d6c7c0b));
  uint64_t x242;
  uint64_t x243;
  fiat_p434_mulx_u64(&x242, &x243, x3, UINT64_C(0xab27973f8311688d));
  uint64_t x244;
  uint64_t x245;
  fiat_p434_mulx_u64(&x244, &x245, x3, UINT64_C(0xacec7367768798c2));
  uint64_t x246;
  uint64_t x247;
  fiat_p434_mulx_u64(&x246, &x247, x3, UINT64_C(0x28e55b65dcd69b30));
  uint64_t x248;
  fiat_p434_uint1 x249;
  fiat_p434_addcarryx_u64(&x248, &x249, 0x0, x247, x244);
  uint64_t x250;
  fiat_p434_uint1 x251;
  fiat_p434_addcarryx_u64(&x250, &x251, x249, x245, x242);
  uint64_t x252;
  fiat_p434_uint1 x253;
  fiat_p434_addcarryx_u64(&x252, &x253, x251, x243, x240);
  uint64_t x254;
  fiat_p434_uint1 x255;
  fiat_p434_addcarryx_u64(&x254, &x255, x253, x241, x238);
  uint64_t x256;
  fiat_p434_uint1 x257;
  fiat_p434_addcarryx_u64(&x256, &x257, x255, x239, x236);
  uint64_t x258;
  fiat_p434_uint1 x259;
  fiat_p434_addcarryx_u64(&x258, &x259, x257, x237, x234);
  uint64_t x260;
  fiat_p434_uint1 x261;
  fiat_p434_addcarryx_u64(&x260, &x261, 0x0, x222, x246);
  uint64_t x262;
  fiat_p434_uint1 x263;
  fiat_p434_addcarryx_u64(&x262, &x263, x261, x224, x248);
  uint64_t x264;
  fiat_p434_uint1 x265;
  fiat_p434_addcarryx_u64(&x264, &x265, x263, x226, x250);
  uint64_t x266;
  fiat_p434_uint1 x267;
  fiat_p434_addcarryx_u64(&x266, &x267, x265, x228, x252);
  uint64_t x268;
  fiat_p434_uint1 x269;
  fiat_p434_addcarryx_u64(&x268, &x269, x267, x230, x254);
  uint64_t x270;
  fiat_p434_uint1 x271;
  fiat_p434_addcarryx_u64(&x270, &x271, x269, x232, x256);
  uint64_t x272;
  fiat_p434_uint1 x273;
  fiat_p434_addcarryx_u64(&x272, &x273, x271, ((x233 + (x193 + (x179 + x155))) + (x219 + x195)), x258);
  uint64_t x274;
  uint64_t x275;
  fiat_p434_mulx_u64(&x274, &x275, x260, UINT64_C(0x2341f27177344));
  uint64_t x276;
  uint64_t x277;
  fiat_p434_mulx_u64(&x276, &x277, x260, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x278;
  uint64_t x279;
  fiat_p434_mulx_u64(&x278, &x279, x260, UINT64_C(0x7bc65c783158aea3));
  uint64_t x280;
  uint64_t x281;
  fiat_p434_mulx_u64(&x280, &x281, x260, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x282;
  uint64_t x283;
  fiat_p434_mulx_u64(&x282, &x283, x260, UINT64_C(0xffffffffffffffff));
  uint64_t x284;
  uint64_t x285;
  fiat_p434_mulx_u64(&x284, &x285, x260, UINT64_C(0xffffffffffffffff));
  uint64_t x286;
  uint64_t x287;
  fiat_p434_mulx_u64(&x286, &x287, x260, UINT64_C(0xffffffffffffffff));
  uint64_t x288;
  fiat_p434_uint1 x289;
  fiat_p434_addcarryx_u64(&x288, &x289, 0x0, x287, x284);
  uint64_t x290;
  fiat_p434_uint1 x291;
  fiat_p434_addcarryx_u64(&x290, &x291, x289, x285, x282);
  uint64_t x292;
  fiat_p434_uint1 x293;
  fiat_p434_addcarryx_u64(&x292, &x293, x291, x283, x280);
  uint64_t x294;
  fiat_p434_uint1 x295;
  fiat_p434_addcarryx_u64(&x294, &x295, x293, x281, x278);
  uint64_t x296;
  fiat_p434_uint1 x297;
  fiat_p434_addcarryx_u64(&x296, &x297, x295, x279, x276);
  uint64_t x298;
  fiat_p434_uint1 x299;
  fiat_p434_addcarryx_u64(&x298, &x299, x297, x277, x274);
  uint64_t x300;
  fiat_p434_uint1 x301;
  fiat_p434_addcarryx_u64(&x300, &x301, 0x0, x260, x286);
  uint64_t x302;
  fiat_p434_uint1 x303;
  fiat_p434_addcarryx_u64(&x302, &x303, x301, x262, x288);
  uint64_t x304;
  fiat_p434_uint1 x305;
  fiat_p434_addcarryx_u64(&x304, &x305, x303, x264, x290);
  uint64_t x306;
  fiat_p434_uint1 x307;
  fiat_p434_addcarryx_u64(&x306, &x307, x305, x266, x292);
  uint64_t x308;
  fiat_p434_uint1 x309;
  fiat_p434_addcarryx_u64(&x308, &x309, x307, x268, x294);
  uint64_t x310;
  fiat_p434_uint1 x311;
  fiat_p434_addcarryx_u64(&x310, &x311, x309, x270, x296);
  uint64_t x312;
  fiat_p434_uint1 x313;
  fiat_p434_addcarryx_u64(&x312, &x313, x311, x272, x298);
  uint64_t x314;
  uint64_t x315;
  fiat_p434_mulx_u64(&x314, &x315, x4, UINT64_C(0x25a89bcdd12a));
  uint64_t x316;
  uint64_t x317;
  fiat_p434_mulx_u64(&x316, &x317, x4, UINT64_C(0x69e16a61c7686d9a));
  uint64_t x318;
  uint64_t x319;
  fiat_p434_mulx_u64(&x318, &x319, x4, UINT64_C(0xabcd92bf2dde347e));
  uint64_t x320;
  uint64_t x321;
  fiat_p434_mulx_u64(&x320, &x321, x4, UINT64_C(0x175cc6af8d6c7c0b));
  uint64_t x322;
  uint64_t x323;
  fiat_p434_mulx_u64(&x322, &x323, x4, UINT64_C(0xab27973f8311688d));
  uint64_t x324;
  uint64_t x325;
  fiat_p434_mulx_u64(&x324, &x325, x4, UINT64_C(0xacec7367768798c2));
  uint64_t x326;
  uint64_t x327;
  fiat_p434_mulx_u64(&x326, &x327, x4, UINT64_C(0x28e55b65dcd69b30));
  uint64_t x328;
  fiat_p434_uint1 x329;
  fiat_p434_addcarryx_u64(&x328, &x329, 0x0, x327, x324);
  uint64_t x330;
  fiat_p434_uint1 x331;
  fiat_p434_addcarryx_u64(&x330, &x331, x329, x325, x322);
  uint64_t x332;
  fiat_p434_uint1 x333;
  fiat_p434_addcarryx_u64(&x332, &x333, x331, x323, x320);
  uint64_t x334;
  fiat_p434_uint1 x335;
  fiat_p434_addcarryx_u64(&x334, &x335, x333, x321, x318);
  uint64_t x336;
  fiat_p434_uint1 x337;
  fiat_p434_addcarryx_u64(&x336, &x337, x335, x319, x316);
  uint64_t x338;
  fiat_p434_uint1 x339;
  fiat_p434_addcarryx_u64(&x338, &x339, x337, x317, x314);
  uint64_t x340;
  fiat_p434_uint1 x341;
  fiat_p434_addcarryx_u64(&x340, &x341, 0x0, x302, x326);
  uint64_t x342;
  fiat_p434_uint1 x343;
  fiat_p434_addcarryx_u64(&x342, &x343, x341, x304, x328);
  uint64_t x344;
  fiat_p434_uint1 x345;
  fiat_p434_addcarryx_u64(&x344, &x345, x343, x306, x330);
  uint64_t x346;
  fiat_p434_uint1 x347;
  fiat_p434_addcarryx_u64(&x346, &x347, x345, x308, x332);
  uint64_t x348;
  fiat_p434_uint1 x349;
  fiat_p434_addcarryx_u64(&x348, &x349, x347, x310, x334);
  uint64_t x350;
  fiat_p434_uint1 x351;
  fiat_p434_addcarryx_u64(&x350, &x351, x349, x312, x336);
  uint64_t x352;
  fiat_p434_uint1 x353;
  fiat_p434_addcarryx_u64(&x352, &x353, x351, ((x313 + (x273 + (x259 + x235))) + (x299 + x275)), x338);
  uint64_t x354;
  uint64_t x355;
  fiat_p434_mulx_u64(&x354, &x355, x340, UINT64_C(0x2341f27177344));
  uint64_t x356;
  uint64_t x357;
  fiat_p434_mulx_u64(&x356, &x357, x340, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x358;
  uint64_t x359;
  fiat_p434_mulx_u64(&x358, &x359, x340, UINT64_C(0x7bc65c783158aea3));
  uint64_t x360;
  uint64_t x361;
  fiat_p434_mulx_u64(&x360, &x361, x340, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x362;
  uint64_t x363;
  fiat_p434_mulx_u64(&x362, &x363, x340, UINT64_C(0xffffffffffffffff));
  uint64_t x364;
  uint64_t x365;
  fiat_p434_mulx_u64(&x364, &x365, x340, UINT64_C(0xffffffffffffffff));
  uint64_t x366;
  uint64_t x367;
  fiat_p434_mulx_u64(&x366, &x367, x340, UINT64_C(0xffffffffffffffff));
  uint64_t x368;
  fiat_p434_uint1 x369;
  fiat_p434_addcarryx_u64(&x368, &x369, 0x0, x367, x364);
  uint64_t x370;
  fiat_p434_uint1 x371;
  fiat_p434_addcarryx_u64(&x370, &x371, x369, x365, x362);
  uint64_t x372;
  fiat_p434_uint1 x373;
  fiat_p434_addcarryx_u64(&x372, &x373, x371, x363, x360);
  uint64_t x374;
  fiat_p434_uint1 x375;
  fiat_p434_addcarryx_u64(&x374, &x375, x373, x361, x358);
  uint64_t x376;
  fiat_p434_uint1 x377;
  fiat_p434_addcarryx_u64(&x376, &x377, x375, x359, x356);
  uint64_t x378;
  fiat_p434_uint1 x379;
  fiat_p434_addcarryx_u64(&x378, &x379, x377, x357, x354);
  uint64_t x380;
  fiat_p434_uint1 x381;
  fiat_p434_addcarryx_u64(&x380, &x381, 0x0, x340, x366);
  uint64_t x382;
  fiat_p434_uint1 x383;
  fiat_p434_addcarryx_u64(&x382, &x383, x381, x342, x368);
  uint64_t x384;
  fiat_p434_uint1 x385;
  fiat_p434_addcarryx_u64(&x384, &x385, x383, x344, x370);
  uint64_t x386;
  fiat_p434_uint1 x387;
  fiat_p434_addcarryx_u64(&x386, &x387, x385, x346, x372);
  uint64_t x388;
  fiat_p434_uint1 x389;
  fiat_p434_addcarryx_u64(&x388, &x389, x387, x348, x374);
  uint64_t x390;
  fiat_p434_uint1 x391;
  fiat_p434_addcarryx_u64(&x390, &x391, x389, x350, x376);
  uint64_t x392;
  fiat_p434_uint1 x393;
  fiat_p434_addcarryx_u64(&x392, &x393, x391, x352, x378);
  uint64_t x394;
  uint64_t x395;
  fiat_p434_mulx_u64(&x394, &x395, x5, UINT64_C(0x25a89bcdd12a));
  uint64_t x396;
  uint64_t x397;
  fiat_p434_mulx_u64(&x396, &x397, x5, UINT64_C(0x69e16a61c7686d9a));
  uint64_t x398;
  uint64_t x399;
  fiat_p434_mulx_u64(&x398, &x399, x5, UINT64_C(0xabcd92bf2dde347e));
  uint64_t x400;
  uint64_t x401;
  fiat_p434_mulx_u64(&x400, &x401, x5, UINT64_C(0x175cc6af8d6c7c0b));
  uint64_t x402;
  uint64_t x403;
  fiat_p434_mulx_u64(&x402, &x403, x5, UINT64_C(0xab27973f8311688d));
  uint64_t x404;
  uint64_t x405;
  fiat_p434_mulx_u64(&x404, &x405, x5, UINT64_C(0xacec7367768798c2));
  uint64_t x406;
  uint64_t x407;
  fiat_p434_mulx_u64(&x406, &x407, x5, UINT64_C(0x28e55b65dcd69b30));
  uint64_t x408;
  fiat_p434_uint1 x409;
  fiat_p434_addcarryx_u64(&x408, &x409, 0x0, x407, x404);
  uint64_t x410;
  fiat_p434_uint1 x411;
  fiat_p434_addcarryx_u64(&x410, &x411, x409, x405, x402);
  uint64_t x412;
  fiat_p434_uint1 x413;
  fiat_p434_addcarryx_u64(&x412, &x413, x411, x403, x400);
  uint64_t x414;
  fiat_p434_uint1 x415;
  fiat_p434_addcarryx_u64(&x414, &x415, x413, x401, x398);
  uint64_t x416;
  fiat_p434_uint1 x417;
  fiat_p434_addcarryx_u64(&x416, &x417, x415, x399, x396);
  uint64_t x418;
  fiat_p434_uint1 x419;
  fiat_p434_addcarryx_u64(&x418, &x419, x417, x397, x394);
  uint64_t x420;
  fiat_p434_uint1 x421;
  fiat_p434_addcarryx_u64(&x420, &x421, 0x0, x382, x406);
  uint64_t x422;
  fiat_p434_uint1 x423;
  fiat_p434_addcarryx_u64(&x422, &x423, x421, x384, x408);
  uint64_t x424;
  fiat_p434_uint1 x425;
  fiat_p434_addcarryx_u64(&x424, &x425, x423, x386, x410);
  uint64_t x426;
  fiat_p434_uint1 x427;
  fiat_p434_addcarryx_u64(&x426, &x427, x425, x388, x412);
  uint64_t x428;
  fiat_p434_uint1 x429;
  fiat_p434_addcarryx_u64(&x428, &x429, x427, x390, x414);
  uint64_t x430;
  fiat_p434_uint1 x431;
  fiat_p434_addcarryx_u64(&x430, &x431, x429, x392, x416);
  uint64_t x432;
  fiat_p434_uint1 x433;
  fiat_p434_addcarryx_u64(&x432, &x433, x431, ((x393 + (x353 + (x339 + x315))) + (x379 + x355)), x418);
  uint64_t x434;
  uint64_t x435;
  fiat_p434_mulx_u64(&x434, &x435, x420, UINT64_C(0x2341f27177344));
  uint64_t x436;
  uint64_t x437;
  fiat_p434_mulx_u64(&x436, &x437, x420, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x438;
  uint64_t x439;
  fiat_p434_mulx_u64(&x438, &x439, x420, UINT64_C(0x7bc65c783158aea3));
  uint64_t x440;
  uint64_t x441;
  fiat_p434_mulx_u64(&x440, &x441, x420, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x442;
  uint64_t x443;
  fiat_p434_mulx_u64(&x442, &x443, x420, UINT64_C(0xffffffffffffffff));
  uint64_t x444;
  uint64_t x445;
  fiat_p434_mulx_u64(&x444, &x445, x420, UINT64_C(0xffffffffffffffff));
  uint64_t x446;
  uint64_t x447;
  fiat_p434_mulx_u64(&x446, &x447, x420, UINT64_C(0xffffffffffffffff));
  uint64_t x448;
  fiat_p434_uint1 x449;
  fiat_p434_addcarryx_u64(&x448, &x449, 0x0, x447, x444);
  uint64_t x450;
  fiat_p434_uint1 x451;
  fiat_p434_addcarryx_u64(&x450, &x451, x449, x445, x442);
  uint64_t x452;
  fiat_p434_uint1 x453;
  fiat_p434_addcarryx_u64(&x452, &x453, x451, x443, x440);
  uint64_t x454;
  fiat_p434_uint1 x455;
  fiat_p434_addcarryx_u64(&x454, &x455, x453, x441, x438);
  uint64_t x456;
  fiat_p434_uint1 x457;
  fiat_p434_addcarryx_u64(&x456, &x457, x455, x439, x436);
  uint64_t x458;
  fiat_p434_uint1 x459;
  fiat_p434_addcarryx_u64(&x458, &x459, x457, x437, x434);
  uint64_t x460;
  fiat_p434_uint1 x461;
  fiat_p434_addcarryx_u64(&x460, &x461, 0x0, x420, x446);
  uint64_t x462;
  fiat_p434_uint1 x463;
  fiat_p434_addcarryx_u64(&x462, &x463, x461, x422, x448);
  uint64_t x464;
  fiat_p434_uint1 x465;
  fiat_p434_addcarryx_u64(&x464, &x465, x463, x424, x450);
  uint64_t x466;
  fiat_p434_uint1 x467;
  fiat_p434_addcarryx_u64(&x466, &x467, x465, x426, x452);
  uint64_t x468;
  fiat_p434_uint1 x469;
  fiat_p434_addcarryx_u64(&x468, &x469, x467, x428, x454);
  uint64_t x470;
  fiat_p434_uint1 x471;
  fiat_p434_addcarryx_u64(&x470, &x471, x469, x430, x456);
  uint64_t x472;
  fiat_p434_uint1 x473;
  fiat_p434_addcarryx_u64(&x472, &x473, x471, x432, x458);
  uint64_t x474;
  uint64_t x475;
  fiat_p434_mulx_u64(&x474, &x475, x6, UINT64_C(0x25a89bcdd12a));
  uint64_t x476;
  uint64_t x477;
  fiat_p434_mulx_u64(&x476, &x477, x6, UINT64_C(0x69e16a61c7686d9a));
  uint64_t x478;
  uint64_t x479;
  fiat_p434_mulx_u64(&x478, &x479, x6, UINT64_C(0xabcd92bf2dde347e));
  uint64_t x480;
  uint64_t x481;
  fiat_p434_mulx_u64(&x480, &x481, x6, UINT64_C(0x175cc6af8d6c7c0b));
  uint64_t x482;
  uint64_t x483;
  fiat_p434_mulx_u64(&x482, &x483, x6, UINT64_C(0xab27973f8311688d));
  uint64_t x484;
  uint64_t x485;
  fiat_p434_mulx_u64(&x484, &x485, x6, UINT64_C(0xacec7367768798c2));
  uint64_t x486;
  uint64_t x487;
  fiat_p434_mulx_u64(&x486, &x487, x6, UINT64_C(0x28e55b65dcd69b30));
  uint64_t x488;
  fiat_p434_uint1 x489;
  fiat_p434_addcarryx_u64(&x488, &x489, 0x0, x487, x484);
  uint64_t x490;
  fiat_p434_uint1 x491;
  fiat_p434_addcarryx_u64(&x490, &x491, x489, x485, x482);
  uint64_t x492;
  fiat_p434_uint1 x493;
  fiat_p434_addcarryx_u64(&x492, &x493, x491, x483, x480);
  uint64_t x494;
  fiat_p434_uint1 x495;
  fiat_p434_addcarryx_u64(&x494, &x495, x493, x481, x478);
  uint64_t x496;
  fiat_p434_uint1 x497;
  fiat_p434_addcarryx_u64(&x496, &x497, x495, x479, x476);
  uint64_t x498;
  fiat_p434_uint1 x499;
  fiat_p434_addcarryx_u64(&x498, &x499, x497, x477, x474);
  uint64_t x500;
  fiat_p434_uint1 x501;
  fiat_p434_addcarryx_u64(&x500, &x501, 0x0, x462, x486);
  uint64_t x502;
  fiat_p434_uint1 x503;
  fiat_p434_addcarryx_u64(&x502, &x503, x501, x464, x488);
  uint64_t x504;
  fiat_p434_uint1 x505;
  fiat_p434_addcarryx_u64(&x504, &x505, x503, x466, x490);
  uint64_t x506;
  fiat_p434_uint1 x507;
  fiat_p434_addcarryx_u64(&x506, &x507, x505, x468, x492);
  uint64_t x508;
  fiat_p434_uint1 x509;
  fiat_p434_addcarryx_u64(&x508, &x509, x507, x470, x494);
  uint64_t x510;
  fiat_p434_uint1 x511;
  fiat_p434_addcarryx_u64(&x510, &x511, x509, x472, x496);
  uint64_t x512;
  fiat_p434_uint1 x513;
  fiat_p434_addcarryx_u64(&x512, &x513, x511, ((x473 + (x433 + (x419 + x395))) + (x459 + x435)), x498);
  uint64_t x514;
  uint64_t x515;
  fiat_p434_mulx_u64(&x514, &x515, x500, UINT64_C(0x2341f27177344));
  uint64_t x516;
  uint64_t x517;
  fiat_p434_mulx_u64(&x516, &x517, x500, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x518;
  uint64_t x519;
  fiat_p434_mulx_u64(&x518, &x519, x500, UINT64_C(0x7bc65c783158aea3));
  uint64_t x520;
  uint64_t x521;
  fiat_p434_mulx_u64(&x520, &x521, x500, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x522;
  uint64_t x523;
  fiat_p434_mulx_u64(&x522, &x523, x500, UINT64_C(0xffffffffffffffff));
  uint64_t x524;
  uint64_t x525;
  fiat_p434_mulx_u64(&x524, &x525, x500, UINT64_C(0xffffffffffffffff));
  uint64_t x526;
  uint64_t x527;
  fiat_p434_mulx_u64(&x526, &x527, x500, UINT64_C(0xffffffffffffffff));
  uint64_t x528;
  fiat_p434_uint1 x529;
  fiat_p434_addcarryx_u64(&x528, &x529, 0x0, x527, x524);
  uint64_t x530;
  fiat_p434_uint1 x531;
  fiat_p434_addcarryx_u64(&x530, &x531, x529, x525, x522);
  uint64_t x532;
  fiat_p434_uint1 x533;
  fiat_p434_addcarryx_u64(&x532, &x533, x531, x523, x520);
  uint64_t x534;
  fiat_p434_uint1 x535;
  fiat_p434_addcarryx_u64(&x534, &x535, x533, x521, x518);
  uint64_t x536;
  fiat_p434_uint1 x537;
  fiat_p434_addcarryx_u64(&x536, &x537, x535, x519, x516);
  uint64_t x538;
  fiat_p434_uint1 x539;
  fiat_p434_addcarryx_u64(&x538, &x539, x537, x517, x514);
  uint64_t x540;
  fiat_p434_uint1 x541;
  fiat_p434_addcarryx_u64(&x540, &x541, 0x0, x500, x526);
  uint64_t x542;
  fiat_p434_uint1 x543;
  fiat_p434_addcarryx_u64(&x542, &x543, x541, x502, x528);
  uint64_t x544;
  fiat_p434_uint1 x545;
  fiat_p434_addcarryx_u64(&x544, &x545, x543, x504, x530);
  uint64_t x546;
  fiat_p434_uint1 x547;
  fiat_p434_addcarryx_u64(&x546, &x547, x545, x506, x532);
  uint64_t x548;
  fiat_p434_uint1 x549;
  fiat_p434_addcarryx_u64(&x548, &x549, x547, x508, x534);
  uint64_t x550;
  fiat_p434_uint1 x551;
  fiat_p434_addcarryx_u64(&x550, &x551, x549, x510, x536);
  uint64_t x552;
  fiat_p434_uint1 x553;
  fiat_p434_addcarryx_u64(&x552, &x553, x551, x512, x538);
  uint64_t x554 = ((x553 + (x513 + (x499 + x475))) + (x539 + x515));
  uint64_t x555;
  fiat_p434_uint1 x556;
  fiat_p434_subborrowx_u64(&x555, &x556, 0x0, x542, UINT64_C(0xffffffffffffffff));
  uint64_t x557;
  fiat_p434_uint1 x558;
  fiat_p434_subborrowx_u64(&x557, &x558, x556, x544, UINT64_C(0xffffffffffffffff));
  uint64_t x559;
  fiat_p434_uint1 x560;
  fiat_p434_subborrowx_u64(&x559, &x560, x558, x546, UINT64_C(0xffffffffffffffff));
  uint64_t x561;
  fiat_p434_uint1 x562;
  fiat_p434_subborrowx_u64(&x561, &x562, x560, x548, UINT64_C(0xfdc1767ae2ffffff));
  uint64_t x563;
  fiat_p434_uint1 x564;
  fiat_p434_subborrowx_u64(&x563, &x564, x562, x550, UINT64_C(0x7bc65c783158aea3));
  uint64_t x565;
  fiat_p434_uint1 x566;
  fiat_p434_subborrowx_u64(&x565, &x566, x564, x552, UINT64_C(0x6cfc5fd681c52056));
  uint64_t x567;
  fiat_p434_uint1 x568;
  fiat_p434_subborrowx_u64(&x567, &x568, x566, x554, UINT64_C(0x2341f27177344));
  uint64_t x569;
  fiat_p434_uint1 x570;
  fiat_p434_subborrowx_u64(&x569, &x570, x568, 0x0, 0x0);
  uint64_t x571;
  fiat_p434_cmovznz_u64(&x571, x570, x555, x542);
  uint64_t x572;
  fiat_p434_cmovznz_u64(&x572, x570, x557, x544);
  uint64_t x573;
  fiat_p434_cmovznz_u64(&x573, x570, x559, x546);
  uint64_t x574;
  fiat_p434_cmovznz_u64(&x574, x570, x561, x548);
  uint64_t x575;
  fiat_p434_cmovznz_u64(&x575, x570, x563, x550);
  uint64_t x576;
  fiat_p434_cmovznz_u64(&x576, x570, x565, x552);
  uint64_t x577;
  fiat_p434_cmovznz_u64(&x577, x570, x567, x554);
  out1[0] = x571;
  out1[1] = x572;
  out1[2] = x573;
  out1[3] = x574;
  out1[4] = x575;
  out1[5] = x576;
  out1[6] = x577;
}

/*
 * The function fiat_p434_nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 */
static void fiat_p434_nonzero(uint64_t* out1, const uint64_t arg1[7]) {
  uint64_t x1 = ((arg1[0]) | ((arg1[1]) | ((arg1[2]) | ((arg1[3]) | ((arg1[4]) | ((arg1[5]) | ((arg1[6]) | (uint64_t)0x0)))))));
  *out1 = x1;
}

/*
 * The function fiat_p434_selectznz is a multi-limb conditional select.
 * Postconditions:
 *   eval out1 = (if arg1 = 0 then eval arg2 else eval arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
static void fiat_p434_selectznz(uint64_t out1[7], fiat_p434_uint1 arg1, const uint64_t arg2[7], const uint64_t arg3[7]) {
  uint64_t x1;
  fiat_p434_cmovznz_u64(&x1, arg1, (arg2[0]), (arg3[0]));
  uint64_t x2;
  fiat_p434_cmovznz_u64(&x2, arg1, (arg2[1]), (arg3[1]));
  uint64_t x3;
  fiat_p434_cmovznz_u64(&x3, arg1, (arg2[2]), (arg3[2]));
  uint64_t x4;
  fiat_p434_cmovznz_u64(&x4, arg1, (arg2[3]), (arg3[3]));
  uint64_t x5;
  fiat_p434_cmovznz_u64(&x5, arg1, (arg2[4]), (arg3[4]));
  uint64_t x6;
  fiat_p434_cmovznz_u64(&x6, arg1, (arg2[5]), (arg3[5]));
  uint64_t x7;
  fiat_p434_cmovznz_u64(&x7, arg1, (arg2[6]), (arg3[6]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
  out1[4] = x5;
  out1[5] = x6;
  out1[6] = x7;
}

/*
 * The function fiat_p434_to_bytes serializes a field element in the Montgomery domain to bytes in little-endian order.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..55]
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0x3ffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0x3], [0x0 ~> 0x0]]
 */
static void fiat_p434_to_bytes(uint8_t out1[56], const uint64_t arg1[7]) {
  uint64_t x1 = (arg1[6]);
  uint64_t x2 = (arg1[5]);
  uint64_t x3 = (arg1[4]);
  uint64_t x4 = (arg1[3]);
  uint64_t x5 = (arg1[2]);
  uint64_t x6 = (arg1[1]);
  uint64_t x7 = (arg1[0]);
  uint64_t x8 = (x7 >> 8);
  uint8_t x9 = (uint8_t)(x7 & UINT8_C(0xff));
  uint64_t x10 = (x8 >> 8);
  uint8_t x11 = (uint8_t)(x8 & UINT8_C(0xff));
  uint64_t x12 = (x10 >> 8);
  uint8_t x13 = (uint8_t)(x10 & UINT8_C(0xff));
  uint64_t x14 = (x12 >> 8);
  uint8_t x15 = (uint8_t)(x12 & UINT8_C(0xff));
  uint64_t x16 = (x14 >> 8);
  uint8_t x17 = (uint8_t)(x14 & UINT8_C(0xff));
  uint64_t x18 = (x16 >> 8);
  uint8_t x19 = (uint8_t)(x16 & UINT8_C(0xff));
  uint8_t x20 = (uint8_t)(x18 >> 8);
  uint8_t x21 = (uint8_t)(x18 & UINT8_C(0xff));
  uint8_t x22 = (uint8_t)(x20 & UINT8_C(0xff));
  uint64_t x23 = (x6 >> 8);
  uint8_t x24 = (uint8_t)(x6 & UINT8_C(0xff));
  uint64_t x25 = (x23 >> 8);
  uint8_t x26 = (uint8_t)(x23 & UINT8_C(0xff));
  uint64_t x27 = (x25 >> 8);
  uint8_t x28 = (uint8_t)(x25 & UINT8_C(0xff));
  uint64_t x29 = (x27 >> 8);
  uint8_t x30 = (uint8_t)(x27 & UINT8_C(0xff));
  uint64_t x31 = (x29 >> 8);
  uint8_t x32 = (uint8_t)(x29 & UINT8_C(0xff));
  uint64_t x33 = (x31 >> 8);
  uint8_t x34 = (uint8_t)(x31 & UINT8_C(0xff));
  uint8_t x35 = (uint8_t)(x33 >> 8);
  uint8_t x36 = (uint8_t)(x33 & UINT8_C(0xff));
  uint8_t x37 = (uint8_t)(x35 & UINT8_C(0xff));
  uint64_t x38 = (x5 >> 8);
  uint8_t x39 = (uint8_t)(x5 & UINT8_C(0xff));
  uint64_t x40 = (x38 >> 8);
  uint8_t x41 = (uint8_t)(x38 & UINT8_C(0xff));
  uint64_t x42 = (x40 >> 8);
  uint8_t x43 = (uint8_t)(x40 & UINT8_C(0xff));
  uint64_t x44 = (x42 >> 8);
  uint8_t x45 = (uint8_t)(x42 & UINT8_C(0xff));
  uint64_t x46 = (x44 >> 8);
  uint8_t x47 = (uint8_t)(x44 & UINT8_C(0xff));
  uint64_t x48 = (x46 >> 8);
  uint8_t x49 = (uint8_t)(x46 & UINT8_C(0xff));
  uint8_t x50 = (uint8_t)(x48 >> 8);
  uint8_t x51 = (uint8_t)(x48 & UINT8_C(0xff));
  uint8_t x52 = (uint8_t)(x50 & UINT8_C(0xff));
  uint64_t x53 = (x4 >> 8);
  uint8_t x54 = (uint8_t)(x4 & UINT8_C(0xff));
  uint64_t x55 = (x53 >> 8);
  uint8_t x56 = (uint8_t)(x53 & UINT8_C(0xff));
  uint64_t x57 = (x55 >> 8);
  uint8_t x58 = (uint8_t)(x55 & UINT8_C(0xff));
  uint64_t x59 = (x57 >> 8);
  uint8_t x60 = (uint8_t)(x57 & UINT8_C(0xff));
  uint64_t x61 = (x59 >> 8);
  uint8_t x62 = (uint8_t)(x59 & UINT8_C(0xff));
  uint64_t x63 = (x61 >> 8);
  uint8_t x64 = (uint8_t)(x61 & UINT8_C(0xff));
  uint8_t x65 = (uint8_t)(x63 >> 8);
  uint8_t x66 = (uint8_t)(x63 & UINT8_C(0xff));
  uint8_t x67 = (uint8_t)(x65 & UINT8_C(0xff));
  uint64_t x68 = (x3 >> 8);
  uint8_t x69 = (uint8_t)(x3 & UINT8_C(0xff));
  uint64_t x70 = (x68 >> 8);
  uint8_t x71 = (uint8_t)(x68 & UINT8_C(0xff));
  uint64_t x72 = (x70 >> 8);
  uint8_t x73 = (uint8_t)(x70 & UINT8_C(0xff));
  uint64_t x74 = (x72 >> 8);
  uint8_t x75 = (uint8_t)(x72 & UINT8_C(0xff));
  uint64_t x76 = (x74 >> 8);
  uint8_t x77 = (uint8_t)(x74 & UINT8_C(0xff));
  uint64_t x78 = (x76 >> 8);
  uint8_t x79 = (uint8_t)(x76 & UINT8_C(0xff));
  uint8_t x80 = (uint8_t)(x78 >> 8);
  uint8_t x81 = (uint8_t)(x78 & UINT8_C(0xff));
  uint8_t x82 = (uint8_t)(x80 & UINT8_C(0xff));
  uint64_t x83 = (x2 >> 8);
  uint8_t x84 = (uint8_t)(x2 & UINT8_C(0xff));
  uint64_t x85 = (x83 >> 8);
  uint8_t x86 = (uint8_t)(x83 & UINT8_C(0xff));
  uint64_t x87 = (x85 >> 8);
  uint8_t x88 = (uint8_t)(x85 & UINT8_C(0xff));
  uint64_t x89 = (x87 >> 8);
  uint8_t x90 = (uint8_t)(x87 & UINT8_C(0xff));
  uint64_t x91 = (x89 >> 8);
  uint8_t x92 = (uint8_t)(x89 & UINT8_C(0xff));
  uint64_t x93 = (x91 >> 8);
  uint8_t x94 = (uint8_t)(x91 & UINT8_C(0xff));
  uint8_t x95 = (uint8_t)(x93 >> 8);
  uint8_t x96 = (uint8_t)(x93 & UINT8_C(0xff));
  uint8_t x97 = (uint8_t)(x95 & UINT8_C(0xff));
  uint64_t x98 = (x1 >> 8);
  uint8_t x99 = (uint8_t)(x1 & UINT8_C(0xff));
  uint64_t x100 = (x98 >> 8);
  uint8_t x101 = (uint8_t)(x98 & UINT8_C(0xff));
  uint64_t x102 = (x100 >> 8);
  uint8_t x103 = (uint8_t)(x100 & UINT8_C(0xff));
  uint64_t x104 = (x102 >> 8);
  uint8_t x105 = (uint8_t)(x102 & UINT8_C(0xff));
  uint64_t x106 = (x104 >> 8);
  uint8_t x107 = (uint8_t)(x104 & UINT8_C(0xff));
  uint8_t x108 = (uint8_t)(x106 >> 8);
  uint8_t x109 = (uint8_t)(x106 & UINT8_C(0xff));
  uint8_t x110 = (uint8_t)(x108 & UINT8_C(0xff));
  out1[0] = x9;
  out1[1] = x11;
  out1[2] = x13;
  out1[3] = x15;
  out1[4] = x17;
  out1[5] = x19;
  out1[6] = x21;
  out1[7] = x22;
  out1[8] = x24;
  out1[9] = x26;
  out1[10] = x28;
  out1[11] = x30;
  out1[12] = x32;
  out1[13] = x34;
  out1[14] = x36;
  out1[15] = x37;
  out1[16] = x39;
  out1[17] = x41;
  out1[18] = x43;
  out1[19] = x45;
  out1[20] = x47;
  out1[21] = x49;
  out1[22] = x51;
  out1[23] = x52;
  out1[24] = x54;
  out1[25] = x56;
  out1[26] = x58;
  out1[27] = x60;
  out1[28] = x62;
  out1[29] = x64;
  out1[30] = x66;
  out1[31] = x67;
  out1[32] = x69;
  out1[33] = x71;
  out1[34] = x73;
  out1[35] = x75;
  out1[36] = x77;
  out1[37] = x79;
  out1[38] = x81;
  out1[39] = x82;
  out1[40] = x84;
  out1[41] = x86;
  out1[42] = x88;
  out1[43] = x90;
  out1[44] = x92;
  out1[45] = x94;
  out1[46] = x96;
  out1[47] = x97;
  out1[48] = x99;
  out1[49] = x101;
  out1[50] = x103;
  out1[51] = x105;
  out1[52] = x107;
  out1[53] = x109;
  out1[54] = x110;
  out1[55] = 0x0;
}

/*
 * The function fiat_p434_from_bytes deserializes a field element in the Montgomery domain from bytes in little-endian order.
 * Preconditions:
 *   0 ≤ bytes_eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = bytes_eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0x3], [0x0 ~> 0x0]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0x3ffffffffffff]]
 */
static void fiat_p434_from_bytes(uint64_t out1[7], const uint8_t arg1[56]) {
  uint64_t x1 = ((uint64_t)(arg1[54]) << 48);
  uint64_t x2 = ((uint64_t)(arg1[53]) << 40);
  uint64_t x3 = ((uint64_t)(arg1[52]) << 32);
  uint64_t x4 = ((uint64_t)(arg1[51]) << 24);
  uint64_t x5 = ((uint64_t)(arg1[50]) << 16);
  uint64_t x6 = ((uint64_t)(arg1[49]) << 8);
  uint8_t x7 = (arg1[48]);
  uint64_t x8 = ((uint64_t)(arg1[47]) << 56);
  uint64_t x9 = ((uint64_t)(arg1[46]) << 48);
  uint64_t x10 = ((uint64_t)(arg1[45]) << 40);
  uint64_t x11 = ((uint64_t)(arg1[44]) << 32);
  uint64_t x12 = ((uint64_t)(arg1[43]) << 24);
  uint64_t x13 = ((uint64_t)(arg1[42]) << 16);
  uint64_t x14 = ((uint64_t)(arg1[41]) << 8);
  uint8_t x15 = (arg1[40]);
  uint64_t x16 = ((uint64_t)(arg1[39]) << 56);
  uint64_t x17 = ((uint64_t)(arg1[38]) << 48);
  uint64_t x18 = ((uint64_t)(arg1[37]) << 40);
  uint64_t x19 = ((uint64_t)(arg1[36]) << 32);
  uint64_t x20 = ((uint64_t)(arg1[35]) << 24);
  uint64_t x21 = ((uint64_t)(arg1[34]) << 16);
  uint64_t x22 = ((uint64_t)(arg1[33]) << 8);
  uint8_t x23 = (arg1[32]);
  uint64_t x24 = ((uint64_t)(arg1[31]) << 56);
  uint64_t x25 = ((uint64_t)(arg1[30]) << 48);
  uint64_t x26 = ((uint64_t)(arg1[29]) << 40);
  uint64_t x27 = ((uint64_t)(arg1[28]) << 32);
  uint64_t x28 = ((uint64_t)(arg1[27]) << 24);
  uint64_t x29 = ((uint64_t)(arg1[26]) << 16);
  uint64_t x30 = ((uint64_t)(arg1[25]) << 8);
  uint8_t x31 = (arg1[24]);
  uint64_t x32 = ((uint64_t)(arg1[23]) << 56);
  uint64_t x33 = ((uint64_t)(arg1[22]) << 48);
  uint64_t x34 = ((uint64_t)(arg1[21]) << 40);
  uint64_t x35 = ((uint64_t)(arg1[20]) << 32);
  uint64_t x36 = ((uint64_t)(arg1[19]) << 24);
  uint64_t x37 = ((uint64_t)(arg1[18]) << 16);
  uint64_t x38 = ((uint64_t)(arg1[17]) << 8);
  uint8_t x39 = (arg1[16]);
  uint64_t x40 = ((uint64_t)(arg1[15]) << 56);
  uint64_t x41 = ((uint64_t)(arg1[14]) << 48);
  uint64_t x42 = ((uint64_t)(arg1[13]) << 40);
  uint64_t x43 = ((uint64_t)(arg1[12]) << 32);
  uint64_t x44 = ((uint64_t)(arg1[11]) << 24);
  uint64_t x45 = ((uint64_t)(arg1[10]) << 16);
  uint64_t x46 = ((uint64_t)(arg1[9]) << 8);
  uint8_t x47 = (arg1[8]);
  uint64_t x48 = ((uint64_t)(arg1[7]) << 56);
  uint64_t x49 = ((uint64_t)(arg1[6]) << 48);
  uint64_t x50 = ((uint64_t)(arg1[5]) << 40);
  uint64_t x51 = ((uint64_t)(arg1[4]) << 32);
  uint64_t x52 = ((uint64_t)(arg1[3]) << 24);
  uint64_t x53 = ((uint64_t)(arg1[2]) << 16);
  uint64_t x54 = ((uint64_t)(arg1[1]) << 8);
  uint8_t x55 = (arg1[0]);
  uint64_t x56 = (x55 + (x54 + (x53 + (x52 + (x51 + (x50 + (x49 + x48)))))));
  uint64_t x57 = (x56 & UINT64_C(0xffffffffffffffff));
  uint64_t x58 = (x7 + (x6 + (x5 + (x4 + (x3 + (x2 + x1))))));
  uint64_t x59 = (x15 + (x14 + (x13 + (x12 + (x11 + (x10 + (x9 + x8)))))));
  uint64_t x60 = (x23 + (x22 + (x21 + (x20 + (x19 + (x18 + (x17 + x16)))))));
  uint64_t x61 = (x31 + (x30 + (x29 + (x28 + (x27 + (x26 + (x25 + x24)))))));
  uint64_t x62 = (x39 + (x38 + (x37 + (x36 + (x35 + (x34 + (x33 + x32)))))));
  uint64_t x63 = (x47 + (x46 + (x45 + (x44 + (x43 + (x42 + (x41 + x40)))))));
  uint64_t x64 = (x63 & UINT64_C(0xffffffffffffffff));
  uint64_t x65 = (x62 & UINT64_C(0xffffffffffffffff));
  uint64_t x66 = (x61 & UINT64_C(0xffffffffffffffff));
  uint64_t x67 = (x60 & UINT64_C(0xffffffffffffffff));
  uint64_t x68 = (x59 & UINT64_C(0xffffffffffffffff));
  out1[0] = x57;
  out1[1] = x64;
  out1[2] = x65;
  out1[3] = x66;
  out1[4] = x67;
  out1[5] = x68;
  out1[6] = x58;
}

